﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


using System.IO;

using ScintillaNET;


namespace SCide
{
    public partial class FormEditor : Form
    {
        ScintillaNET.Scintilla scintilla;

        string filePath;
        public FormEditor(string filePath)
        {
            InitializeComponent();
            this.filePath = filePath;
        }


        private void SetLanguage(string language)
        {
            if ("ini".Equals(language, StringComparison.OrdinalIgnoreCase))
            {
                // Reset/set all styles and prepare _scintilla for custom lexing
                
                //ActiveDocument.IniLexer = true;
                //IniLexer.Init(ActiveDocument.Scintilla);

                
            }
            else
            {
                // Use a built-in lexer and configuration
                //ActiveDocument.IniLexer = false;
                //ActiveDocument.Scintilla.ConfigurationManager.Language = language;

                //// Smart indenting...
                //if ("cs".Equals(language, StringComparison.OrdinalIgnoreCase))
                //    ActiveDocument.Scintilla.Indentation.SmartIndentType = SmartIndent.CPP;
                //else
                //    ActiveDocument.Scintilla.Indentation.SmartIndentType = SmartIndent.None;
            }
        }

        private void FormEditor_Load(object sender, EventArgs e)
        {
            Text = filePath;
            

            scintilla = new ScintillaNET.Scintilla();

            this.scintilla.Dock = System.Windows.Forms.DockStyle.Fill;
            this.scintilla.LineWrapping.VisualFlags = ScintillaNET.LineWrappingVisualFlags.End;
            this.scintilla.Location = new System.Drawing.Point(0, 0);
            this.scintilla.Margins.Margin1.AutoToggleMarkerNumber = 0;
            this.scintilla.Margins.Margin1.IsClickable = true;
            this.scintilla.Margins.Margin2.Width = 16;
            this.scintilla.Name = "scintilla";
            this.scintilla.Size = new System.Drawing.Size(292, 266);
            this.scintilla.TabIndex = 0;
            this.Controls.Add(this.scintilla);
            scintilla.Text = File.ReadAllText(filePath);
            scintilla.UndoRedo.EmptyUndoBuffer();
            scintilla.Modified = false;            
            
            SetLanguage("html");

            //scintilla.SupressControlCharacters = true;
            scintilla.Whitespace.Mode = WhitespaceMode.VisibleAlways;
            scintilla.EndOfLine.IsVisible = true;
            scintilla.Margins.Margin0.Width = 40;
            scintilla.Whitespace.Mode = WhitespaceMode.VisibleAlways;

            scintilla.LineWrapping.Mode = LineWrappingMode.Word;
            scintilla.LineWrapping.Mode = LineWrappingMode.None;


            scintilla.Zoom = 5;

            //ActiveDocument.IniLexer = false;
            //ActiveDocument.Scintilla.ConfigurationManager.Language = language;

            scintilla.ConfigurationManager.Language = "html";


            scintilla.Indentation.TabWidth = 2;
                /*
SCI_SETTABWIDTH(int widthInChars)
SCI_GETTABWIDTH
SCI_SETUSETABS(bool useTabs)
SCI_GETUSETABS
SCI_SETINDENT(int widthInChars)
SCI_GETINDENT
SCI_SETTABINDENTS(bool tabIndents)
SCI_GETTABINDENTS
SCI_SETBACKSPACEUNINDENTS(bool bsUnIndents)
SCI_GETBACKSPACEUNINDENTS
SCI_SETLINEINDENTATION(int line, int indentation)
SCI_GETLINEINDENTATION(int line)
SCI_GETLINEINDENTPOSITION(int line)
SCI_SETINDENTATIONGUIDES(int indentView)
SCI_GETINDENTATIONGUIDES
SCI_SETHIGHLIGHTGUIDE(int column)
SCI_GETHIGHLIGHTGUIDE
                 * */

            

            //this.scintilla.ModifiedChanged += new System.EventHandler(this.scintilla_ModifiedChanged);
            //this.scintilla.StyleNeeded += new System.EventHandler<ScintillaNET.StyleNeededEventArgs>(this.scintilla_StyleNeeded);


            //DocumentForm doc = new DocumentForm();
            ////SetScintillaToCurrentOptions(doc);
            //doc.Scintilla.Text = File.ReadAllText(filePath);
            //doc.Scintilla.UndoRedo.EmptyUndoBuffer();
            //doc.Scintilla.Modified = false;
            //doc.Text = Path.GetFileName(filePath);
            //doc.FilePath = filePath;
            //TextBox editor = new TextBox();
            //editor.Multiline = true;
            //editor.Dock = DockStyle.Fill;
            
            //this.Controls.Add(editor);

        }
    }
}
