/*==================================================================*/
/* Script generated with: MW Designer Version 4.20, Build 052       */
/* Project Filename: D:\Daten\Dp60\DBS-Dev-40\dbs\Eisenbahn.sql     */
/* Project Name:     Projekt HS-Harz                                */
/* Author:           HS-Harz                                        */
/* DBMS:             Firebird-DBF                                   */
/* Copyright:        Copyright by ???                               */
/* Generated on:     19.12.2011 09:14:10                            */
/*==================================================================*/


/*==================================================================*/
/*  Tables                                                          */
/*==================================================================*/
CREATE TABLE DB_FAHRT (
  FAHRPLAN_NR  INTEGER  NOT NULL,
  DATUM  DATE(0)  NOT NULL,
  ABFAHRT  TIME(0)  NOT NULL,
  LOKNR  INTEGER  NOT NULL,
  WAGNR  INTEGER  NOT NULL,
  STRECKEN_NR  INTEGER  NOT NULL,

  CONSTRAINT PK_FAHRPLAN_NR  PRIMARY KEY (FAHRPLAN_NR)
);

CREATE TABLE STRECKE (
  STRECKEN_NR  INTEGER  NOT NULL,
  NAME  VARCHAR(40),
  B1  INTEGER  NOT NULL,
  B2  INTEGER  NOT NULL,

  CONSTRAINT PK_STRECKEN_NR  PRIMARY KEY (STRECKEN_NR)
);

CREATE TABLE BAHNHOF (
  BNR  INTEGER  NOT NULL,
  NAME  VARCHAR(40),

  CONSTRAINT PK_BNR  PRIMARY KEY (BNR)
);

CREATE TABLE LOK (
  LOKNR  INTEGER  NOT NULL,
  TYP  VARCHAR(40),

  CONSTRAINT PK_LOKNR  PRIMARY KEY (LOKNR)
);

CREATE TABLE WAGGON (
  WAGNR  INTEGER  NOT NULL,
  SITZPLAETZE  NUMERIC  NOT NULL,

  CONSTRAINT PK_WAGNR  PRIMARY KEY (WAGNR)
);

CREATE TABLE KUNDE (
  KNR  INTEGER  NOT NULL,
  NAME  VARCHAR(40)  NOT NULL,
  VORNAME  VARCHAR(40),
  PLZ  VARCHAR(40),
  ORT  VARCHAR(40),
  STRASSE  VARCHAR(40),

  CONSTRAINT PK_KNR  PRIMARY KEY (KNR)
);

CREATE TABLE DB_SEGMENT (
  SEG_NR  INTEGER  NOT NULL,
  PREIS  NUMERIC  NOT NULL,
  DAUER  NUMERIC,
  B1  INTEGER  NOT NULL,
  B2  INTEGER  NOT NULL,

  CONSTRAINT PK_SEG_NR  PRIMARY KEY (SEG_NR)
);

CREATE TABLE KUNDE_DB_FAHRT (
  ANZ_PLAETZE  NUMERIC  DEFAULT 0  NOT NULL,
  KNR  INTEGER  NOT NULL,
  FAHRPLAN_NR  INTEGER  NOT NULL
);

CREATE TABLE STRECKEN_SEGMENTE (
  L_NR  INTEGER  NOT NULL,
  STRECKEN_NR  INTEGER  NOT NULL,
  SEG_NR  INTEGER  NOT NULL
);




/*==================================================================*/
/*  Foreign Keys                                                    */
/*==================================================================*/
ALTER TABLE STRECKE ADD CONSTRAINT 
   FK_BAHNHOF_STRECKE1 FOREIGN KEY (B1) REFERENCES BAHNHOF(BNR);


ALTER TABLE STRECKE ADD CONSTRAINT 
   FK_BAHNHOF_STRECKE2 FOREIGN KEY (B2) REFERENCES BAHNHOF(BNR);


ALTER TABLE DB_SEGMENT ADD CONSTRAINT 
   FK_BAHNHOF_DB_SEGMENT1 FOREIGN KEY (B1) REFERENCES BAHNHOF(BNR);


ALTER TABLE DB_SEGMENT ADD CONSTRAINT 
   FK_BAHNHOF_DB_SEGMENT2 FOREIGN KEY (B2) REFERENCES BAHNHOF(BNR);


ALTER TABLE DB_FAHRT ADD CONSTRAINT 
   FK_LOK_DB_FAHRT FOREIGN KEY (LOKNR) REFERENCES LOK(LOKNR);


ALTER TABLE DB_FAHRT ADD CONSTRAINT 
   FK_WAGGON_DB_FAHRT FOREIGN KEY (WAGNR) REFERENCES WAGGON(WAGNR);


ALTER TABLE DB_FAHRT ADD CONSTRAINT 
   FK_STRECKE_DB_FAHRT FOREIGN KEY (STRECKEN_NR) REFERENCES STRECKE(STRECKEN_NR);


ALTER TABLE KUNDE_DB_FAHRT ADD CONSTRAINT 
   FK_KUNDE_KUNDE_DB_FAHRT FOREIGN KEY (KNR) REFERENCES KUNDE(KNR);


ALTER TABLE KUNDE_DB_FAHRT ADD CONSTRAINT 
   FK_DB_FAHRT_KUNDE_DB_FAHRT FOREIGN KEY (FAHRPLAN_NR) REFERENCES DB_FAHRT(FAHRPLAN_NR);


ALTER TABLE STRECKEN_SEGMENTE ADD CONSTRAINT 
   FK_STRECKE_STRECKEN_SEGMENTE FOREIGN KEY (STRECKEN_NR) REFERENCES STRECKE(STRECKEN_NR);


ALTER TABLE STRECKEN_SEGMENTE ADD CONSTRAINT 
   FK_DB_SEGM_STRECKEN_SEGMENTE FOREIGN KEY (SEG_NR) REFERENCES DB_SEGMENT(SEG_NR);






/*==================================================================*/
/*  Check-Constraints                                               */
/*==================================================================*/
/*==================================================================*/
/*  Indexes                                                         */
/*==================================================================*/


















/*==================================================================*/
/*  Generatoren                                                     */
/*==================================================================*/
