﻿using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Win32;

using System.Windows.Forms;
using System.Collections;

namespace html
{
    class Basis
    {


        /// <summary>
        /// Remove the Path from the complete filename
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <returns></returns>
        public static String getFilename(String sPathFilename)
        {
            int k = sPathFilename.LastIndexOf('\\');
            if (k >= 0)
            {
                return sPathFilename.Substring(k + 1);
            }
            else
            {
                return sPathFilename;
            }
        }  // getFilename


        public static String getFilenameExt(String sPathFilename)
        {
            int k = sPathFilename.LastIndexOf('.');
            if (k >= 0)
            {
                return sPathFilename.Substring(k + 1);
            }
            else
            {
                return "";
            }
        }  // getFilename


        public static String getPath(String sPathFilename)
        {
            int k = sPathFilename.LastIndexOf('\\');
            if (k >= 0)
            {
                return sPathFilename.Substring(k);
            }
            else
            {
                return "";
            }
        }  // getFilename


        /// <summary>
        /// Ersetzt die Dateierweiterung des 1. Parameters; c:\daten\1.xhtml , css ==> c:\c:\daten\1.css
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <param name="sExt"></param>
        /// <returns></returns>
        public static String changeFilenameExt(String sPathFilename, string sExt)
        {
            int k = sPathFilename.LastIndexOf('.');
            if (k >= 0)
            {
                return sPathFilename.Substring(0,k+1)+sExt;  // k+1 fuer Punkt
            }
            else
            {
                return sPathFilename;
            }
        }  // getFilename

        public static DialogResult readYesNoCancel(string message, string title)
        {
            return MessageBox.Show(message, title, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);   // Exclamation
        }

        public static bool readYesNo(string message, string title)
        {
            return MessageBox.Show(message, title, MessageBoxButtons.YesNo, MessageBoxIcon.Question)==DialogResult.Yes;
        }


        public static String getHex(int x) {
          String sErg = String.Format("{0:X}", x);
          if (sErg.Length == 1) sErg = "0" + sErg;
          return sErg;
        }


        public static String ReadRegString(string root, string KeyName)
        {
            string sKey;
            RegistryKey regist;
            try
            {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return "";
                }
                else
                {
                    if (regist.GetValue(KeyName) == null)
                        sKey = "";
                    else
                    {
                        sKey = regist.GetValue(KeyName).ToString();
                    }
                    return sKey;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Writing registry " + KeyName.ToUpper());
                return "";
            }
        }  // readRegString


        public static long ReadRegLong(string root, string KeyName)
        {
            long lKey;
            string sKey;
            RegistryKey regist;
            try
            {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else
                {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else
                    {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = (long)Convert.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Reading registry long" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegLong


        public static int ReadRegInt(string root, string KeyName)
        {
            int lKey;
            string sKey;
            RegistryKey regist;
            try
            {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else
                {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else
                    {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = (int)Convert.ToInt32(sKey);
                            //.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Reading registry int" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegInt

        public static ulong ReadRegULong(string root, string KeyName)
        {
            string sKey;
            ulong lKey = 0;
            RegistryKey regist;
            try
            {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else
                {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else
                    {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = Convert.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Reading registry double" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegLong


        public static double ReadRegDouble(string root, string KeyName)
        {
            string sKey;
            double dKey = 0;
            RegistryKey regist;
            try
            {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0.0;
                }
                else
                {
                    if (regist.GetValue(KeyName) == null)
                        dKey = 0.0;
                    else
                    {
                        sKey = regist.GetValue(KeyName).ToString();
                        dKey = Convert.ToDouble(sKey);
                    }
                    return dKey;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Reading registry double" + KeyName.ToUpper());
                return 0.0;
            }
        }  // readRegDouble



        // WriteWriteWriteWriteWriteWriteWriteWriteWriteWriteWriteWrite


        public static bool WriteRegString(string root, string KeyName, string Value)
        {
            try
            {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else
                {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.String);
                    return true;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Writing registry string" + KeyName.ToUpper());
                return false;
            }
        }



        public static bool WriteRegULong(string root, string KeyName, ulong Value)
        {
            try
            {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else
                {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.DWord);
                    return true;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Writing registry long" + KeyName.ToUpper());
                return false;
            }
        }

        // fuer long int etc
        public static bool WriteRegInt(string root, string KeyName, int Value)
        {
            try
            {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else
                {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.DWord);
                    return true;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Writing registry int" + KeyName.ToUpper());
                return false;
            }
        }



        public static bool WriteRegDouble(string root, string KeyName, double Value)
        {
            try
            {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else
                {
                    rKey.SetValue(KeyName, Value.ToString(), RegistryValueKind.String);
                    return true;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Writing registry double" + KeyName.ToUpper());
                return false;
            }
        }

        public static bool ReadRegBool(string root, string KeyName) // 1
        {           
            bool bKey;
            RegistryKey regist;
            try
            {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else
                {
                    if (regist.GetValue(KeyName) == null)
                        bKey = false;
                    else
                    {
                        int value = (int)regist.GetValue(KeyName);
                        bKey = value == 1;                     
                    }
                    return bKey;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Reading registry bool" + KeyName.ToUpper());
                return false;
            }
        }  // readRegBool

        public static bool WriteRegBool(string root, string KeyName, bool Value)
        {
            try
            {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null)
                {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else
                {
                    if (Value)
                        rKey.SetValue(KeyName, 1, RegistryValueKind.DWord);  // Bool geht nicht                    
                    else
                        rKey.SetValue(KeyName, 0, RegistryValueKind.DWord);  // Bool geht nicht                    
                    return true;
                }
            }
            catch (Exception e)
            {
                // OOOOH, ein Fehler
                MessageBox.Show(e.ToString(), "Writing registry bool" + KeyName.ToUpper());
                return false;
            }
        }






    }
}
