﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
// using System.Linq;
using System.Text;

using System.Windows.Forms;

using System.IO;

using ScintillaNET;



namespace html
{
    public partial class ChildForm : Form
    {
       

        
        public ScintillaNET.Scintilla scintilla;

        private String sFilename = SingVar.C_NONAME;

        private StatusStrip statusStrip1;
        private ToolStripStatusLabel toolStripStatusLabel1;

        public string Filename
        {
            get { return sFilename; }
        }

        public bool isModify()  {
            return scintilla.Modified; 
        }

        public void setModify(bool value) {
            scintilla.Modified = value; 
        }



        public ChildForm(string sFilename)
        {
            //MessageBox.Show("ChildForm konstr sFilename");
            InitializeComponent();
            this.sFilename = sFilename;
        }

        public ChildForm()
        {
            //MessageBox.Show("ChildForm konstr");
            InitializeComponent();
            this.sFilename = SingVar.C_NONAME;
        }

       
        // musste geaendert werden vpn private auf protected oder public
        protected void ChildForm_Load(object sender, EventArgs e)
        {   
            scintilla = new ScintillaNET.Scintilla();
            scintilla.Location = new System.Drawing.Point(59, 90);
            Sci_Middleware.initSci(ref scintilla);

            
            scintilla.Name = "scintilla1";
            scintilla.Size = new System.Drawing.Size(379, 224);
            scintilla.TabIndex = 0;
            scintilla.Dock = DockStyle.Fill;
            this.toolStripContainer1.ContentPanel.Controls.Add(scintilla);
                      

            if (sFilename != SingVar.C_NONAME)
            {
                Text = sFilename;
                if (File.Exists(sFilename))
                {
                    scintilla.Text = File.ReadAllText(sFilename);
                }
                Sci_Middleware.setLanguage_intern(ref scintilla, sFilename);                
            }
            else
            {
               Text = SingVar.C_NONAME;
               scintilla.ConfigurationManager.Language = "html";               
            }
            scintilla.Modified = false;

            scintilla.ModifiedChanged += new System.EventHandler(scintilla_ModifiedChanged);
            scintilla.StyleNeeded += new System.EventHandler<ScintillaNET.StyleNeededEventArgs>(this.scintilla_StyleNeeded);

            initGUI();
          
        }  // ChildForm_Load

        private void scintilla_ModifiedChanged(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = " modify";
        }

        private void scintilla_StyleNeeded(object sender, StyleNeededEventArgs e)
        {
            // Style the _text
            //if (_iniLexer)
              IniLexer.StyleNeeded((Scintilla)sender, e.Range);
              toolStripStatusLabel1.Text = " IniLexer";
        }



        private void initGUI() {
            statusStrip1 = new System.Windows.Forms.StatusStrip();
            toolStripStatusLabel1 = new System.Windows.Forms.ToolStripStatusLabel();
            statusStrip1.SuspendLayout();
            //SuspendLayout();
            // 
            // The following code example demonstrates the syntax for setting
            // various StatusStrip properties.
            statusStrip1.Dock = System.Windows.Forms.DockStyle.Bottom;
            statusStrip1.GripStyle = System.Windows.Forms.ToolStripGripStyle.Visible;
            statusStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            toolStripStatusLabel1});
            statusStrip1.LayoutStyle = System.Windows.Forms.ToolStripLayoutStyle.HorizontalStackWithOverflow;
            statusStrip1.Location = new System.Drawing.Point(0, 0);
            statusStrip1.Name = "statusStrip1";
            statusStrip1.ShowItemToolTips = true;
            statusStrip1.Size = new System.Drawing.Size(292, 22);
            statusStrip1.SizingGrip = false;
            statusStrip1.Stretch = false;
            statusStrip1.TabIndex = 0;
            statusStrip1.Text = "statusStrip1";
            // 
            // toolStripStatusLabel1
            // 
            toolStripStatusLabel1.Name = "toolStripStatusLabel1";
            toolStripStatusLabel1.Size = new System.Drawing.Size(109, 17);
            toolStripStatusLabel1.Text = "toolStripStatusLabel1";


            Controls.Add(statusStrip1);
            statusStrip1.ResumeLayout(false);
            statusStrip1.PerformLayout();
        }






        public void CloseWindow()
        {
        }

        public void save()
        {
            LineCollection lines = scintilla.Lines;
             FileStream oFile = new FileStream(sFilename, FileMode.Create);
             StreamWriter oStream = new StreamWriter(oFile);

             // string sText = scintilla.Text;
             // oStream.Write(ChangeUmlaute(sText));  // End of Line ist im Text
             foreach (Line line in lines)
             {
                 string value = line.Text;
                 oStream.Write(  ChangeUmlaute(value) );  // End of Line ist im Text
             }
            
             oStream.Close();
             oFile.Close();

            scintilla.Modified = false;
            toolStripStatusLabel1.Text = " ";
        }

        string ChangeUmlaute(string sText) 
        {
          sText = ChangeUmlaut("Ä","&#196;", sText);
          sText = ChangeUmlaut("ä","&#228;",sText);
          sText = ChangeUmlaut("Ö","&#214;",sText);
          sText = ChangeUmlaut("ö","&#246;",sText);
          sText = ChangeUmlaut("Ü","&#220;",sText);
          sText = ChangeUmlaut("ü","&#252;",sText);
          sText = ChangeUmlaut("ß","&#223;",sText);
            return sText;
        }


        string ChangeUmlaut(string sChar, string sNewChar, string sText)
        {
            int i;
            int al1, al2;
            int startindex = 0;

            al1 = sText.IndexOf("alert", StringComparison.Ordinal);  // StringComparison.CurrentCultureIgnoreCase);
           if (al1 >= 0)
               al2 = sText.IndexOf(")", al1 + 4, StringComparison.Ordinal);
           else
               al2 = -1;


           i = sText.IndexOf(sChar, StringComparison.Ordinal);

          while (i>0) {

              //if (((i >= ji1) && (i <= ji2)) || ((i >= pi1) && (i <= pi2)) || ((i >= qi1) && (i <= qi2)))
              if ( (al1>=0)   && (i >= al1) && (i <= al2) )
                  startindex = i + 1;
              else
              {
                  sText = sText.Substring(0, i) + sNewChar + sText.Substring(i+1); // funktioniert nur, wenn sChar Laenge 1 ist 
                  startindex = i + 1;
              }
            //  al1 = sText.IndexOf("alert", startindex, StringComparison.CurrentCultureIgnoreCase);
            //if (al1 >= 0)
            //    al2 = sText.IndexOf(")", al1 + 4, StringComparison.CurrentCultureIgnoreCase);
            //else
            //    al2 = -1;
              i = sText.IndexOf(sChar, startindex, StringComparison.Ordinal);             
          }
          
  
          //i := pos(#0,sText);
          //while i>0 do
          //begin
          //   sText := copy(sText,1,i-1) + sChar + copy(sText,i+1,length(sText));
          //   i := pos(#0,sText);
          //end;
          return sText;
        }


        public void saveAs(string sFilename)
        {
            this.sFilename = sFilename;
            save();
        }

        public void setLanguage(String lang) {
            scintilla.ConfigurationManager.Language = lang;
            scintilla.Update();            
        }



        private void ChildForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (scintilla.Modified)
            {
                DialogResult dr = Basis.readYesNoCancel("Die Änderung speichern?\r\n" + sFilename, "Fenster schließen");
                if (dr == DialogResult.Cancel)
                {
                    // Stop closing
                    e.Cancel = true;
                    return;
                }
                else if (dr == DialogResult.Yes)
                {
                    // Try to save before closing
                    save();
                    e.Cancel = false;
                    return;
                }
                scintilla.Modified = false;  // damit keine weitere Medlung erscheint
            }
            e.Cancel = false;
            // Event FormClosing kommt vorher, in Parent gibt es dann keine Fenster mehr
            SingVar instance= SingVar.getInstance();                        
            instance.saveFile(sFilename);
        }


     

//---------------


        public void setWhiteSpace(bool bWhitespace)
        {
            if (bWhitespace)
                scintilla.Whitespace.Mode = WhitespaceMode.VisibleAlways;
            else
                scintilla.Whitespace.Mode = WhitespaceMode.Invisible;

        }

        public void setMnEndOfLine(bool bEndOfLine)
        {
            scintilla.EndOfLine.IsVisible = bEndOfLine;
        }



        public void setLineNumbers(bool bLineNumbers)
        {
            if (bLineNumbers)
                scintilla.Margins.Margin0.Width = 35; // LINE_NUMBERS_MARGIN_WIDTH;
            else
                scintilla.Margins.Margin0.Width = 0;
        }




        public void setWordWrap(bool bWordWrap)
        {
            if (bWordWrap)
                scintilla.LineWrapping.Mode = LineWrappingMode.Word;
            else
                scintilla.LineWrapping.Mode = LineWrappingMode.None;
        }


        public void setZoom(int zoomLevel)
        {
            scintilla.Zoom = zoomLevel;
            if (scintilla.LineWrapping.Mode != LineWrappingMode.None)
            {
                if (zoomLevel < 10)
                    scintilla.Margins.Margin0.Width = (int)(40 + zoomLevel / 2);
                else
                    if (zoomLevel < 18)
                        scintilla.Margins.Margin0.Width = (int)(40 + (zoomLevel + 15) / 1.7);
                    else
                        scintilla.Margins.Margin0.Width = (int)(40 + (zoomLevel + 25) / 1.7);
            }
        }

        public void setTabLength(int tabLength)
        {
            scintilla.Indentation.TabWidth = tabLength;
        }


        public void search()
        {
            scintilla.FindReplace.ShowFind();
        }


        public void searchreplace()
        {
            scintilla.FindReplace.ShowReplace();
        }

        public void MakeUpper()
        {
            scintilla.Commands.Execute(BindableCommand.UpperCase);
        }

        public void MakeLower()
        {
            scintilla.Commands.Execute(BindableCommand.LowerCase);
        }

        public void CommentRange()
        {
            scintilla.Commands.Execute(BindableCommand.StreamComment);
        }

        public void CommentLine()
        {
            scintilla.Commands.Execute(BindableCommand.LineComment);
        }
        public void UnCommentLine()
        {
            scintilla.Commands.Execute(BindableCommand.LineUncomment);
        }


        public void AutoComplete()
        {
            scintilla.AutoComplete.Show();
        }

        public void InsertSnippet()
        {
            scintilla.Snippets.ShowSnippetList();
        }


        public void SurroundWithSnippets()
        {
            scintilla.Snippets.ShowSurroundWithList();
        }

        public void ShowGoto()
        {
            scintilla.GoTo.ShowGoToDialog();
        }




        public void ToggleBookmarks()
        {
            Line currentLine = scintilla.Lines.Current;
            if (scintilla.Markers.GetMarkerMask(currentLine) == 0)
            {
                currentLine.AddMarker(0);
            }
            else
            {
                currentLine.DeleteMarker(0);
            }
        }


        public void PreviousMarker()
        {
            //	 I've got to redo this whole FindNextMarker/FindPreviousMarker Scheme
            Line l = scintilla.Lines.Current.FindPreviousMarker(1);
            if (l != null)
                l.Goto();
        }
        public void NextMarker()
        {
            //	 I've got to redo this whole FindNextMarker/FindPreviousMarker Scheme
            Line l = scintilla.Lines.Current.FindNextMarker(1);
            if (l != null)
                l.Goto();
        }
        public void ClearMarker()
        {
            scintilla.Markers.DeleteAll(0);
        }


        public void DropMarker()
        {
            scintilla.DropMarkers.Drop();
        }
        public void CollectMarker()
        {
            scintilla.DropMarkers.Collect();
        }


        public void undo()
        {
            scintilla.UndoRedo.Undo();
        }
        public void redo()
        {
            scintilla.UndoRedo.Redo();
        }


        public void cut()
        {
            scintilla.Clipboard.Cut();
        }
        public void copy()
        {
            scintilla.Clipboard.Copy();
        }
        public void paste()
        {
            scintilla.Clipboard.Paste();
        }
        public void selectAll()
        {
            scintilla.Selection.SelectAll();
        }

        public void PrintPreview()
        {
            scintilla.Printing.PrintPreview();
        }
        public void Print()
        {
            scintilla.Printing.Print();
        }


        public void FoldLevel()
        {
            scintilla.Lines.Current.FoldExpanded = true;
        }

        public void UnfoldLevel()
        {
            scintilla.Lines.Current.FoldExpanded = false;
        }

        public void FoldAll()
        {
            foreach (Line l in scintilla.Lines)
            {
                l.FoldExpanded = true;
            }
        }

        public void UnfoldAll()
        {
            foreach (Line l in scintilla.Lines)
            {
                l.FoldExpanded = false;
            }
        }

        public void NavigateForward()
        {
            scintilla.DocumentNavigation.NavigateForward();
        }

        public void NavigateBackward()
        {
            scintilla.DocumentNavigation.NavigateBackward();
        }


        private void timer1_Tick(object sender, EventArgs e)
        {
            /*

            int position = 0;
            string sText = "";
            scintilla.InsertText(position, sText);

             * * Text = scintilla.CurrentPos.ToString();
            int caretPosition;
            string s = scintilla.GetCurrentLine(out caretPosition);  // Position innerhalb der Zeile
            Text = "(" + caretPosition + ")" + s;

            Line currentLine = scintilla.Lines.Current;
            // currentLine.Text

            Text = "(" + currentLine.StartPosition + ")" + currentLine.VisibleLineNumber;
            // currentLine.StartPosition  Position, wann die Zeile im Text beginnt  n-1
            // currentLine.VisibleLineNumber   aktuelle Zeile n-1
            */
        }
        
    }
}
