﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace html
{
    public partial class FCoords : Form
    {
        private const int C_POINT = 1;
        private const int C_RECTANGLE = 2;
        private const int C_CIRCLE = 3;
        private const int C_POLYLINE = 4;

        private bool bRetCode = false;
        private string sFilename = "";
        private bool _bStart=false;
        //private bool bInsertCoords=false; 

        private int  anzCoords=0;
        private string sPoints;
        private int xCoord = 0;
        private int yCoord = 0;

        private int CoordsTyp = 0;
        
        public bool RetCode
        {
            get { return bRetCode; }
        }

        public string getCoords()
        {
            switch (CoordsTyp)
            {
                case C_POINT: return "<area shape=\"point\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                case C_RECTANGLE: return "<area shape=\"rect\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                case C_CIRCLE: return "<area shape=\"circle\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                case C_POLYLINE: return "<area shape=\"poly\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                default: return "Error in Case getCoords";
            }
        }

        public FCoords()
        {
            InitializeComponent();
        }

        private void FCoords_Load(object sender, EventArgs e)
        {
            _bStart = true;

          cbZoom.Items.Clear();
          cbZoom.Items.Add("100 %");
          cbZoom.Items.Add("200 %");
          cbZoom.Items.Add("300 %");
          cbZoom.Items.Add("400 %");
          cbZoom.Items.Add("500 %");
          cbZoom.Items.Add("600 %");
          cbZoom.Items.Add("700 %");
          cbZoom.Items.Add("800 %");
          cbZoom.SelectedIndex = 0;
          _bStart = false;

          Txy.Text = "";
          
          TPoints.Text = "";

          pictureBox1.Dock = DockStyle.Fill;                
        }

        private void BnSaveClose_Click(object sender, EventArgs e)
        {
            bRetCode = true;
            Close();
        }

        private void BnOpenImage_Click(object sender, EventArgs e)
        {
              OpenFileDialog openFileDialog = new OpenFileDialog();
              openFileDialog.DefaultExt = ".bmp";
              openFileDialog.InitialDirectory = System.Environment.CurrentDirectory; //  Environment.GetFolderPath(Environment.SpecialFolder.Personal);
              openFileDialog.Filter =   "Bild-Dateien (*.bmp;*.jpg;*.jpeg)|*.bmp;*.jpg;*.jpeg|" +
                                        "JPG-Dateien (*.jpg;*.jpeg)|*.jpg;*.jpeg|" + 
                                        "BMP-Dateien (*.bmp)|*.bmp|" +
                                        
                                        "PING-Dateien (*.png)|*.png|"+
                                        "GIF-Dateien (*.gif)|*.gif|" +
                                        "Alle Dateien (*.*)|*.*";

              openFileDialog.Multiselect = true;
              openFileDialog.Title = "Bildatei Öffnen";
              if (openFileDialog.ShowDialog(this) == DialogResult.OK)
              {
                  sFilename = openFileDialog.FileName;

                  pictureBox1.Image = System.Drawing.Image.FromFile(sFilename);
                  Graphics g = pictureBox1.CreateGraphics();
                  g.DrawImage(pictureBox1.Image,
                      new Rectangle(0, 0, pictureBox1.Width, pictureBox1.Height),  //where to draw the image
                      new Rectangle(0, 0, pictureBox1.Width, pictureBox1.Height),  //the portion of the image to draw
                          GraphicsUnit.Pixel);

                  pictureBox1.Update();
                  vScrollBar1.Minimum = 0;
                  hScrollBar1.Minimum = 0;
                  // test, if Image to small
                  // two Problems:  width and height
                  if (pictureBox1.Image.Height < pictureBox1.Height)
                  {
                      vScrollBar1.Maximum = 0;
                  }
                  else
                  {
                      vScrollBar1.Maximum = pictureBox1.Image.Height - pictureBox1.Height + hScrollBar1.Height + 1;
                  }

                  if (pictureBox1.Image.Width < pictureBox1.Width)
                  {
                      hScrollBar1.Maximum = 0;
                  }
                  else
                  {
                      hScrollBar1.Maximum = pictureBox1.Image.Width - pictureBox1.Width + vScrollBar1.Width + 1;
                  }

                  
                  hScrollBar1.Value = 0;
                  vScrollBar1.Value = 0;


                  anzCoords=0;
                  sPoints="";
              }
        }


        private void vhScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            int z = cbZoom.SelectedIndex + 1;

            //Create a graphics object and draw a portion of the image in the PictureBox.
            Graphics g = pictureBox1.CreateGraphics();

            int xWidth = pictureBox1.Width;
            int yHeight = pictureBox1.Height;

            int x;
            int y;

            if (e.ScrollOrientation == ScrollOrientation.HorizontalScroll)
            {
                x = e.NewValue;
                y = vScrollBar1.Value;
            }
            else //e.ScrollOrientation == ScrollOrientation.VerticalScroll
            {
                y = e.NewValue;
                x = hScrollBar1.Value;
            }

            g.DrawImage(pictureBox1.Image,
              new Rectangle(0, 0, xWidth * z, yHeight * z),  //where to draw the image
              new Rectangle(x, y, xWidth, yHeight),  //the portion of the image to draw
              GraphicsUnit.Pixel);

            pictureBox1.Update();

        }




        private void cbZoom_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (_bStart) return;
            int z = cbZoom.SelectedIndex + 1;
            Graphics g = pictureBox1.CreateGraphics();
            g.DrawImage(pictureBox1.Image,
                new Rectangle(0, 0, pictureBox1.Width * z, pictureBox1.Height * z),  //where to draw the image
                new Rectangle(0, 0, pictureBox1.Width, pictureBox1.Height),  //the portion of the image to draw
                    GraphicsUnit.Pixel);

            pictureBox1.Update();
            if (pictureBox1.Image.Height*z < pictureBox1.Height)
            {
                vScrollBar1.Maximum = 0;
            }
            else
            {
                vScrollBar1.Maximum = pictureBox1.Image.Height * z - pictureBox1.Height + hScrollBar1.Height + 1;
            }

            if (pictureBox1.Image.Width * z < pictureBox1.Width)
            {
                hScrollBar1.Maximum = 0;
            }
            else
            {
                hScrollBar1.Maximum = pictureBox1.Image.Width*z - pictureBox1.Width + vScrollBar1.Width + 1;
            }
            hScrollBar1.Value = 0;
            vScrollBar1.Value = 0;
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            //if (!bInsertCoords) return;            
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                int xx, yy,ir;
                double r;
                int z = cbZoom.SelectedIndex + 1;
                int x2 = e.X / z + hScrollBar1.Value;
                int y2 = e.Y / z + vScrollBar1.Value;


                switch (CoordsTyp)
                {
                    case C_POINT:     sPoints = x2.ToString() + ", " + y2.ToString();
                                break;
                    case C_RECTANGLE:     if (anzCoords>=2) {   // Linie
                                      anzCoords=0;
                                      sPoints="";
                                }
                               if (anzCoords>0)
                                 sPoints+=",  "+x2.ToString() + ", " + y2.ToString();
                               else
                                   sPoints=x2.ToString() + ", " + y2.ToString();
                               anzCoords++;          
                            break;
                    case C_CIRCLE: if (anzCoords >= 2)
                            {   // Circle
                                anzCoords = 0;
                                sPoints = "";
                            }
                            switch (anzCoords)
                            {
                                case 0:     anzCoords=1;
                                            sPoints=x2.ToString() + ", " + y2.ToString();
                                            xCoord=x2;
                                            yCoord=y2;
                                            break;
                                case 1:    anzCoords=2;
                                            xx = xCoord-x2;
                                            yy = yCoord-y2;
                                            r = Math.Sqrt(xx*xx + yy*yy);
                                            ir = (int) Math.Round(r);
                                            sPoints += ", " + ir.ToString();
                                            break;
                                default:    MessageBox.Show("Fehlerhafter Case-Fall, Modul FCoords, Methode pictureBox1_MouseDown"+
                                            "\r\nanzCoords: " + anzCoords.ToString(), "Fehlerhafter Case-Fall");
                                            break;
                            }
                            break;
                    case C_POLYLINE: anzCoords++;  // Polyline
                            if (anzCoords>1) sPoints+=",  ";
                            sPoints += x2.ToString() + ", " + y2.ToString();
                            break;
                }
                TPoints.Text = sPoints;
            }
        }  // pictureBox1_MouseDown

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            int z = cbZoom.SelectedIndex + 1;
            //lx.Text = (e.X).ToString();
            //Ty.Text = (e.Y).ToString();
            Txy.Text = ((e.X / z + hScrollBar1.Value)).ToString()   +  " / "+((e.Y / z + vScrollBar1.Value)).ToString();
        }

        private void cbZoom_Click(object sender, EventArgs e)
        {
            if (cbZoom.SelectedIndex == 0)
            {
                pictureBox1.SizeMode = PictureBoxSizeMode.Normal;
            }
            else
            {
                pictureBox1.SizeMode = PictureBoxSizeMode.Zoom;
                SizeF sf = new SizeF((cbZoom.SelectedIndex + 1)*100, (cbZoom.SelectedIndex + 1)*100);
                pictureBox1.Scale(sf);
            }
            
        }

        private void FCoords_ResizeEnd(object sender, EventArgs e)
        {
            if (_bStart) return;
            int z = cbZoom.SelectedIndex + 1;
            Graphics g = pictureBox1.CreateGraphics();
            g.DrawImage(pictureBox1.Image,
                new Rectangle(0, 0, pictureBox1.Width * z, pictureBox1.Height * z),  //where to draw the image
                new Rectangle(0, 0, pictureBox1.Width, pictureBox1.Height),  //the portion of the image to draw
                    GraphicsUnit.Pixel);

            pictureBox1.Update();
            if (pictureBox1.Image.Height * z < pictureBox1.Height)
            {
                vScrollBar1.Maximum = 0;
            }
            else
            {
                vScrollBar1.Maximum = pictureBox1.Image.Height * z - pictureBox1.Height + hScrollBar1.Height + 1;
            }

            if (pictureBox1.Image.Width * z < pictureBox1.Width)
            {
                hScrollBar1.Maximum = 0;
            }
            else
            {
                hScrollBar1.Maximum = pictureBox1.Image.Width * z - pictureBox1.Width + vScrollBar1.Width + 1;
            }
            hScrollBar1.Value = 0;
            vScrollBar1.Value = 0;

        }

        private void schließenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void MnPoint_Click(object sender, EventArgs e)
        {
            setCoordsTyp(C_POINT);
        }

        private void MnRecttangle_Click(object sender, EventArgs e)
        {
            setCoordsTyp(C_RECTANGLE);
        }

        private void MnCircle_Click(object sender, EventArgs e)
        {
            setCoordsTyp(C_CIRCLE);
        }

        private void MnPolyline_Click(object sender, EventArgs e)
        {
            setCoordsTyp(C_POLYLINE);
        }


        private void setCoordsTyp(int index)
        {
            CoordsTyp = index;
            anzCoords = 0;
            sPoints = "";
            TPoints.Text = "";
        }

        private void FCoords_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (anzCoords > 0)
            {
                DialogResult dr = Basis.readYesNoCancel("Die Änderung speichern?\r\n" , "Fenster schließen");
                if (dr == DialogResult.Cancel)
                {
                    // Stop closing
                    e.Cancel = true;
                }
                else if (dr == DialogResult.Yes)
                {
                    bRetCode = true;
                }
            }

        }

    }
}
