﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace html
{
    public partial class FOptions : Form
    {
        private bool bRetCode = false;

        public bool RetCode
        {
            get { return bRetCode; }
        }

        public FOptions()
        {
            InitializeComponent();
        }

        private void FOptions_Load(object sender, EventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            TBrowser5.Text = singvar.Broswer5;
            TBrowser6.Text = singvar.Broswer6;

            iTabLength.Value = singvar.TabLength;

            chkShowStartWindow.Checked = Basis.ReadRegBool(SingVar.C_REG_ADR, "noshowstartwindow");
            
            int option = Basis.ReadRegInt(SingVar.C_REG_ADR, "ohnestartoption");
            rbMDI.Checked = true;
            rbRegister.Checked = option == 2;

            rbMenuesMerge.Checked = true;
            option = Basis.ReadRegInt(SingVar.C_REG_ADR, "menuesmerge");            
            rbMenuesNoMerge.Checked = option == 2;


        }

        private void BnOpen5_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.DefaultExt = ".exe";
            openFileDialog.InitialDirectory = System.Environment.CurrentDirectory; ; //  Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            openFileDialog.Filter = "Programme (*.exe)|*.exe|" +
                                    "|Alle Dateien (*.*)|*.*";

            openFileDialog.Multiselect = false;
            openFileDialog.Title = "5. Browser auswählen";

            if (openFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                TBrowser5.Text = openFileDialog.FileName;
            }
        }

        private void BnOpen6_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.DefaultExt = ".exe";
            openFileDialog.InitialDirectory = System.Environment.CurrentDirectory; ; //  Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            openFileDialog.Filter = "Programme (*.exe)|*.exe|" +
                                    "|Alle Dateien (*.*)|*.*";

            openFileDialog.Multiselect = false;
            openFileDialog.Title = "6. Browser auswählen";

            if (openFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                TBrowser6.Text = openFileDialog.FileName;
            }
        }

        private void BnOk_Click(object sender, EventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            singvar.Broswer5 = TBrowser5.Text;
            singvar.Broswer6 = TBrowser6.Text;

            singvar.TabLength = (int) iTabLength.Value;

            Basis.WriteRegBool(SingVar.C_REG_ADR, "noshowstartwindow", chkShowStartWindow.Checked);

            if (rbMDI.Checked)
            {                
                Basis.WriteRegInt(SingVar.C_REG_ADR, "startoption", 1);
            }
            if (rbRegister.Checked)
            {             
                Basis.WriteRegInt(SingVar.C_REG_ADR, "startoption", 2);
            }

            if (rbMenuesMerge.Checked) {
                Basis.WriteRegInt(SingVar.C_REG_ADR, "menuesmerge", 1);
                singvar.MenueMerge = System.Windows.Forms.MergeAction.Insert;
            }
            if (rbMenuesNoMerge.Checked) {
                Basis.WriteRegInt(SingVar.C_REG_ADR, "menuesmerge", 2);
                singvar.MenueMerge = System.Windows.Forms.MergeAction.MatchOnly; // NoAction
            }
            
            

            bRetCode = true;
            Close();
        }

        private void BnEsc_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void FOptions_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
            {
                BnOk_Click(sender, e);
            }
        }

    }
}
