﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;  // run

using System.IO;


namespace html
{
    public partial class MDIParent1 : Form
    {
        private int childFormNumber = 0;

        private int _zoomLevel = 2;

        public MDIParent1()
        {
            InitializeComponent();
        }

        private void MDIParent1_Load(object sender, EventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            foreach (string sFilename in singvar.files)
            {
                OpenFile(sFilename);
            }            
            MnBrowser5.Text = Basis.getFilename(singvar.Broswer5);
            MnBrowser6.Text = Basis.getFilename(singvar.Broswer6);

            MnWhitespace.Checked = singvar.WithWhitespace;
            MnWordWrap.Checked = singvar.WordWrap;
            MnEndOfLine.Checked = singvar.EndOfLine;
            MnLineNumbers.Checked = singvar.LineNumbers;
            _zoomLevel = singvar.ZoomLevel;

            if (singvar.MDISetting)
            {
                Top = singvar.MDITop;
                Left = singvar.MDILeft;
                Width = singvar.MDIWidth;
                Height = singvar.MDIHeight;
            }
        }  // MDIParent1_Load


        private void MnNew_Click(object sender, EventArgs e)
        {
            FRadio5 frame = new FRadio5();
            frame.ShowDialog();
            if (frame.RetCode!=-1)
            {
                string sFilename = SaveNewFile(frame.RetCode);
                if (sFilename.Equals("")) return;

                switch (frame.RetCode)
                {
                    case FRadio5.C_HTMLCSS:
                    case FRadio5.C_HTML5:
                        string sFile2 = Basis.changeFilenameExt(sFilename, "css");
                        if (frame.RetCode==FRadio5.C_HTMLCSS)
                            SingVar.SaveCSS_Html_BasicXHTML(sFilename, sFile2);
                        else
                            SingVar.SaveCSS_Html_HTML5(sFilename, sFile2);

                        HTMLForm childForm1 = new HTMLForm(sFilename); // SingVar.C_NONAME);
                        childForm1.MdiParent = this;
                        childForm1.Text = "Fenster " + childFormNumber++;
                        childForm1.Show();
                        setOptions(childForm1);
                        CSSForm childForm2 = new CSSForm(sFile2);
                        childForm2.MdiParent = this;
                        childForm2.Text = "Fenster " + childFormNumber++;
                        childForm2.Show();
                        setOptions(childForm2);
                        LayoutMdi(MdiLayout.TileVertical);
                        break;


                    case FRadio5.C_HTML:
                    case FRadio5.C_PHP:
                                        HTMLForm childForm3 = new HTMLForm(sFilename); // SingVar.C_NONAME);
                                        childForm3.MdiParent = this;
                                        childForm3.Text = "Fenster " + childFormNumber++;
                                        childForm3.Show();
                                        setOptions(childForm3);
                                        break;

                    case FRadio5.C_CSS:
                                        CSSForm childForm4 = new CSSForm(sFilename); // SingVar.C_NONAME);
                                        childForm4.MdiParent = this;
                                        childForm4.Text = "Fenster " + childFormNumber++;
                                        childForm4.Show();
                                        setOptions(childForm4);
                                        break;

                    default: MessageBox.Show("Fehler in Modul NewClick, Falsche Dateiauswahl");
                                        break;
                }
            }
        }  // MnNew_Click



        private string SaveNewFile(int filetyp)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.InitialDirectory = System.Environment.CurrentDirectory; // Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            switch (filetyp)
            {
                case FRadio5.C_HTMLCSS:
                case FRadio5.C_HTML:
                case FRadio5.C_HTML5:
                                    saveFileDialog.Filter = "HTML-Dateien (*.xhtml)|*.xhtml|" +
                                    "HTML-Dateien (*.html;*.htm)|*.html;*.html;*.htm|" +
                                    "HTML-Dateien (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.html;*.htm|" +
                                    "CSS-Dateien (*.css)|*.css|XML-Dateien (*.xml;*.xsl)|*.xml;*.xsl|" +
                                    "PHP-Dateien (*.php)|*.php|Alle Dateien (*.*)|*.*";
                                    saveFileDialog.DefaultExt = "xhtml";
                                    break;

                case FRadio5.C_PHP:
                                    saveFileDialog.Filter = "PHP-Dateien (*.php)|*.php|"+
                                        "HTML-Dateien (*.xhtml)|*.xhtml|" +
                                    "HTML-Dateien (*.html;*.htm)|*.html;*.html;*.htm|" +
                                    "HTML-Dateien (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.html;*.htm|" +
                                    "Alle Dateien (*.*)|*.*";
                                    saveFileDialog.DefaultExt = "php";
                                    break;

                case FRadio5.C_CSS:
                                    saveFileDialog.Filter = "CSS-Dateien (*.css)|*.css|" +
                                    "HTML-Dateien (*.xhtml)|*.xhtml|" +
                                    "HTML-Dateien (*.html;*.htm)|*.html;*.html;*.htm|" +
                                    "HTML-Dateien (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.html;*.htm|" +
                                    "XML-Dateien (*.xml;*.xsl)|*.xml;*.xsl|" +
                                    "PHP-Dateien (*.php)|*.php|Alle Dateien (*.*)|*.*";
                                    saveFileDialog.DefaultExt = "css";
                                    break;

                default: MessageBox.Show("Fehler in Modul SaveNewFile, Falscher Dateityp");
                    break;
            }

            if (saveFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                return saveFileDialog.FileName;
            }
            else
            {
                return "";
            }
        }


        private void MnOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.DefaultExt=".XHTML";
            openFileDialog.InitialDirectory = "d:\\cdaten\\html"; // System.Environment.CurrentDirectory; //  Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            openFileDialog.Filter = "HTML-Dateien (*.xhtml)|*.xhtml|"+
            "HTML-Dateien (*.html;*.htm)|*.html;*.htm|"+
            "HTML-Dateien (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.html;*.htm|"+
            "CSS-Dateien (*.css)|*.css|XML-Dateien (*.xml;*.xsl)|*.xml;*.xsl|"+
            "PHP-Dateien (*.php)|*.php|Alle Dateien (*.*)|*.*";

            openFileDialog.Multiselect = true;
            openFileDialog.Title = "Datei(en) Öffnen";
  


            if (openFileDialog.ShowDialog(this) == DialogResult.OK)
            {                
                foreach (String sFilename in openFileDialog.FileNames)
                {
                    checkFileopen(sFilename);
                    String xhtml = Basis.getFilenameExt(sFilename).ToLower();
                    if (xhtml.Equals("xhtml")) {
                        String filenameCSS = Basis.changeFilenameExt(sFilename,"css");
                        bool gefunden = false;
                        foreach (String sFilename2 in openFileDialog.FileNames) {
                            if (sFilename2.Equals(filenameCSS, StringComparison.OrdinalIgnoreCase)) {
                                gefunden = true;
                            }                            
                        }
                        if (!gefunden && File.Exists(filenameCSS)) {
                            checkFileopen(filenameCSS);
                        }
                    }
                }
                
            }
        }
         // .Click+=  Delegate Funktion aus SingVar.  OldFiles
        public void checkFileopen(string sFilename) {
            bool bIsOpen = false;
            foreach (Form childForm in MdiChildren) {
                string s = ((ChildForm)childForm).Filename;
                if (sFilename.Equals(((ChildForm)childForm).Filename, StringComparison.OrdinalIgnoreCase)) {
                    childForm.Activate();
                    bIsOpen = true;
                    break;
                }
            }
            if (!bIsOpen) {
                OpenFile(sFilename);
                SingVar instance = SingVar.getInstance();
                instance.deleteFile(sFilename);

                String filenameCSS = Basis.changeFilenameExt(sFilename, "css");
                bool gefunden = false;
                foreach (Form childForm in MdiChildren) {
                    string s = ((ChildForm)childForm).Filename;
                    if (filenameCSS.Equals(((ChildForm)childForm).Filename, StringComparison.OrdinalIgnoreCase)) {
                        childForm.Activate();
                        gefunden = true;
                        break;
                    }
                }
                if (!gefunden && File.Exists(filenameCSS)) {
                    OpenFile(filenameCSS);
                    instance.deleteFile(filenameCSS);
                }
            }
        }

        private void OpenFile(String sFilename)
        {
            string sExt = Basis.getFilenameExt(sFilename).ToLower();
            if (sExt.Equals("css") ) {
                CSSForm child = new CSSForm(sFilename);
                child.MdiParent = this;            
                child.Show();
                setOptions(child);
            }
            else {
                HTMLForm child = new HTMLForm(sFilename);  // 
                child.MdiParent = this;            
                child.Show();
                setOptions(child);
            }
        }

        private void setOptions(ChildForm childForm)
        {
            childForm.setWhiteSpace(MnWhitespace.Checked);

            childForm.setWordWrap(MnWordWrap.Checked);

            childForm.setMnEndOfLine(MnEndOfLine.Checked);

            childForm.setLineNumbers(MnLineNumbers.Checked);

            SingVar singvar = SingVar.getInstance();
            childForm.setTabLength(singvar.TabLength);

            childForm.setZoom(_zoomLevel);
        }


        private ChildForm getActiceForm()
        {
            Form form = this.ActiveMdiChild;
            if (form==null)
                return null;
            else
                return (ChildForm) form;            
        }


        private void MnPrint_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();            
            if (child!=null) child.Print();                            
        }

        private void MnPrintPreview_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();            
            if (child!=null) child.PrintPreview();            
        }

        private void MnPrintSetup_Click(object sender, EventArgs e)
        {
            //
        }

        private void MnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void MnUndo_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();
            if (child != null) child.undo();
        }

        private void MnRedo_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();            
            if (child!=null) child.redo();
        }

        private void MnCut_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();
            if (child != null) child.cut();
        }

        private void MnCopy_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();
            if (child != null) child.copy();
        }

        private void MnPaste_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();
            if (child != null) child.paste();
        }

        private void MnSelectAll_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();
            if (child != null) child.selectAll();
        }

        private void MnToolBar_Click(object sender, EventArgs e)
        {
            toolStrip.Visible = MnToolBar.Checked;
        }

        private void MnStatusBar_Click(object sender, EventArgs e)
        {
            statusStrip.Visible = MnStatusBar.Checked;
        }


        private void MnCascade_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.Cascade);
        }

        private void MnTileVertical_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileVertical);
        }

        private void MnTileHorizontal_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void MnArrangeIcons_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.ArrangeIcons);
        }

        private void MnCloseAll_Click(object sender, EventArgs e)
        {
            foreach (Form childForm in MdiChildren)
            {
                childForm.Close();  // CloseWindow
            }
        }

        private void MnProgInfo_Click(object sender, EventArgs e)
        {
            FProgInfo dialog = new FProgInfo();
            dialog.ShowDialog();
        }

        private void MnContents_Click(object sender, EventArgs e)
        {
            // 
        }

        private void MnSave_Click(object sender, EventArgs e)
        {
            ChildForm child = getActiceForm();
            if (child != null) {
                if (child.Filename.Equals(SingVar.C_NONAME))
                    MnSaveAs_Click(sender, e);
                else
                    child.save();
            }
        }

        private void MnSaveAll_Click(object sender, EventArgs e)
        {
            foreach (Form childForm in MdiChildren)
            {
                ((ChildForm)childForm).save();
            }
        }



        private void MnSaveAs_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.InitialDirectory = System.Environment.CurrentDirectory; //  Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            saveFileDialog.Filter = "HTML-Dateien (*.xhtml)|*.xhtml|" +
            "HTML-Dateien (*.html;*.htm)|*.html;*.html;*.htm|" +
            "HTML-Dateien (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.html;*.htm|" +
            "CSS-Dateien (*.css)|*.css|XML-Dateien (*.xml;*.xsl)|*.xml;*.xsl|" +
            "PHP-Dateien (*.php)|*.php|Alle Dateien (*.*)|*.*";
            if (saveFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                string FileName = saveFileDialog.FileName;
                ChildForm child = getActiceForm();
               if (child != null) child.saveAs(FileName);
            }
        }


        private void MnWhitespace_Click(object sender, EventArgs e)
        {
            MnWhitespace.Checked = ! MnWhitespace.Checked;
            SingVar singvar = SingVar.getInstance();
            singvar.WithWhitespace = MnWhitespace.Checked;

            foreach (Form childForm in MdiChildren)
            {
                ((ChildForm)childForm).setWhiteSpace(MnWhitespace.Checked);
            }

        }

        private void MnEndOfLine_Click(object sender, EventArgs e)
        {
            MnEndOfLine.Checked = ! MnEndOfLine.Checked;
            SingVar singvar = SingVar.getInstance();
            singvar.EndOfLine = MnEndOfLine.Checked;
            foreach (Form childForm in MdiChildren)
            {
                ((ChildForm)childForm).setMnEndOfLine(MnEndOfLine.Checked);
            }
        }

        private void MnZoomIn_Click(object sender, EventArgs e)
        {
            _zoomLevel++;
            UpdateAllScintillaZoom();
        }

        private void MnZoomOut_Click(object sender, EventArgs e)
        {
            if (_zoomLevel > 0)
            {
                _zoomLevel--;
                UpdateAllScintillaZoom();
            }
        }

        private void MnResetZoom_Click(object sender, EventArgs e)
        {
            _zoomLevel = 0;
            UpdateAllScintillaZoom();
        }

        private void UpdateAllScintillaZoom()
        {
            SingVar singvar = SingVar.getInstance();            
            singvar.ZoomLevel=_zoomLevel;

            foreach (Form childForm in MdiChildren)
            {
                ((ChildForm)childForm).setZoom(_zoomLevel);
            }
        }


        private void MnLineNumbers_Click(object sender, EventArgs e)
        {
            MnLineNumbers.Checked = !MnLineNumbers.Checked;
            SingVar singvar = SingVar.getInstance();
            singvar.LineNumbers = MnLineNumbers.Checked;            

            foreach (Form childForm in MdiChildren)
            {
                ((ChildForm)childForm).setLineNumbers(MnLineNumbers.Checked);
            }

        }

        private void MnWordWrap_Click(object sender, EventArgs e)
        {
            MnWordWrap.Checked = !MnWordWrap.Checked;
            SingVar singvar = SingVar.getInstance();
            singvar.WordWrap = MnWordWrap.Checked;
            foreach (Form childForm in MdiChildren)
            {
                ((ChildForm)childForm).setWordWrap(MnWordWrap.Checked);
            }
        }

        private void MnLanguage_Assembly_Click(object sender, EventArgs e)
        {
            setLanguage("asm");
        }

        private void MnLanguage_asp_Click(object sender, EventArgs e)
        {
            setLanguage("asp");
        }

        private void MnLanguage_bash_Click(object sender, EventArgs e)
        {
            setLanguage("bash");
        }

        private void MnLanguage_batch_Click(object sender, EventArgs e)
        {
            setLanguage("batch");
        }

        private void MnLanguage_CSS_Click(object sender, EventArgs e)
        {
            setLanguage("cs");
        }

        private void MnLanguage_CPP_Click(object sender, EventArgs e)
        {
            setLanguage("cpp");
        }

        private void MnLanguage_D_Click(object sender, EventArgs e)
        {
            setLanguage("d");
        }

        private void MnLanguage_html_Click(object sender, EventArgs e)
        {
            setLanguage("html");
        }

        private void MnLanguage_ini_Click(object sender, EventArgs e)
        {
            setLanguage("ini");
        }

        private void MnLanguage_lisp_Click(object sender, EventArgs e)
        {
            setLanguage("lisp");
        }

        private void MnLanguage_Pascal_Click(object sender, EventArgs e)
        {
            setLanguage("pascal");
        }

        private void MnLanguage_perl_Click(object sender, EventArgs e)
        {
            setLanguage("perl");
        }

        private void MnLanguage_plainText_Click(object sender, EventArgs e)
        {
            setLanguage("plaintext");
        }

        private void MnLanguage_python_Click(object sender, EventArgs e)
        {
            setLanguage("python");
        }

        private void MnLanguage_SQL_Click(object sender, EventArgs e)
        {
            setLanguage("sql");
        }

        private void MnLanguage_vb_Click(object sender, EventArgs e)
        {
            setLanguage("vb");
        }

        private void MnLanguage_xml_Click(object sender, EventArgs e)
        {
            setLanguage("xml");
        }

        private void cSSToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLanguage("css");
        }

        private void phpToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setLanguage("php");
        }


        private void setLanguage(String lang)
        {
            ChildForm panel = this.getActiceForm();
            if (panel != null) panel.setLanguage(lang);
        }

        private void MnGoto_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.ShowGoto();            
        }

        private void MnToggleBookmarks_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.ToggleBookmarks();
        }

        private void MnPreviousBookmark_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.PreviousMarker();
        }


        private void MnNextBookmark_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.NextMarker();
        }

        private void MnClearBookmarks_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.ClearMarker();
        }

        private void MnDropMarkers_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.DropMarker();
        }

        private void MnCollectMarkers_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.CollectMarker();
        }

        private void MnMakeUpper_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.MakeUpper();
        }

        private void MnMakeLower_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.MakeLower();
        }

        private void MnCommentRange_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.CommentRange();
        }

        private void MnCommentLine_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.CommentLine();
        }

        private void MnUncommentLine_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.UnCommentLine();
        }

        private void MnAutoComplete_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.AutoComplete();
        }

        private void MnInsertSnippet_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.InsertSnippet();
        }

        private void MnSnippet_Surroundwith_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.SurroundWithSnippets();
        }

        private void MnFind_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.search();
        }

        private void MnReplace_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.searchreplace();
        }



        private void MnOptions_Click(object sender, EventArgs e)
        {            
            FOptions dialog = new FOptions();
            dialog.ShowDialog();
            if (dialog.RetCode)
            {
                SingVar singvar = SingVar.getInstance();
                foreach (Form childForm in MdiChildren)
                {
                    ((ChildForm)childForm).setTabLength( singvar.TabLength );
                }
            }
        }



        private void MnFoldLevel_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.FoldLevel();
        }

        private void MnUnfoldLevel_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.UnfoldLevel();
        }

        private void MnFoldAll_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.FoldAll();
        }

        private void MnUnfoldAll_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.UnfoldAll();
        }

        private void MnNavigateForward_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.NavigateForward();
        }

        private void MnNavigateBackward_Click(object sender, EventArgs e)
        {
            ChildForm panel = getActiceForm();
            if (panel != null) panel.NavigateBackward();
        }

        private void MDIParent1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = false;
            ChildForm panel;
            // Check, ob mindestens ein fenster nicht schliessen will
            foreach (Form childForm in MdiChildren)
            {
                panel = ((ChildForm)childForm);
                if (panel.isModify())
                {
                    DialogResult dr = Basis.readYesNoCancel("Die Änderung speichern?\r\n" + panel.Filename, "Fenster schließen");
                    if (dr == DialogResult.Cancel)
                    {
                        // Stop closing
                        e.Cancel = true;
                    }
                    else if (dr == DialogResult.Yes)
                    {
                        panel.save(); // Try to save before closing
                    }
                }

            }  // foreach (TabPage page in tabControl1.TabPages)
            if (!e.Cancel)
            {
                // nun alle modified zurücksetzen
                foreach (Form childForm in MdiChildren)
                {
                    panel = ((ChildForm)childForm);
                    panel.setModify( false );
                }  // foreach (TabPage page in tabControl1.TabPages)
            }

            // das Eintragen der aktuellen Dateien geschieht beim lokalen Schliessen
            SingVar instance= SingVar.getInstance();
            instance.saveOldFiles2Registry();
        }

        private void MDIParent1_FormClosed(object sender, FormClosedEventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            singvar.MDISetting = true;
            singvar.MDITop = Top;
            singvar.MDILeft = Left;
            singvar.MDIWidth = Width;
            singvar.MDIHeight = Height;

        }


        private void MnRegisterfensterStarten_Click(object sender, EventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            singvar.files.Clear();

            foreach (Form childForm in MdiChildren)
            {
                ((ChildForm)childForm).save();
                singvar.files.Add(((ChildForm)childForm).Filename);
            }
            RegParent1 frame = new RegParent1();
            frame.Show();
            // Close();
        }

        

        

        // OLD_FILES, reicht aus  .Click+=
        private void MainFile_Click(object sender, EventArgs e)
        {            
            SingVar instance = SingVar.getInstance();
            SingVar.callBack_checkFileopen delgt = checkFileopen;
            instance.createOldFilesMenuItems(MainFile, delgt);
        }

        // wenn Alt D gedrueckt wird
        private void MainFile_DropDownOpened(object sender, EventArgs e)
        {
            MainFile_Click(sender, e);
        }


        private void MnCalc_Click(object sender, EventArgs e)
        {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "calc.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start(); 
        }

        private void MnDos_Click(object sender, EventArgs e)
        {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "cmd.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start();
        }

        private void MnNotepad_Click(object sender, EventArgs e)
        {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "notepad.exe";
            ChildForm child = getActiceForm();
            if (child != null) 
                Prog.StartInfo.Arguments = child.Filename;
            else
                Prog.StartInfo.Arguments = "";            
            Prog.Start(); 
        }

        private void MnExplorer_Click(object sender, EventArgs e)
        {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "explorer.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start(); 
        }

        private void MnClearRegistryOldFiles_Click(object sender, EventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            singvar.clearOldFiles();
        }

        private void BnFirefox_Click(object sender, EventArgs e)
        {
            string sBrowser = "C:\\Program Files (x86)\\Mozilla Firefox\\firefox.exe";
            if (!File.Exists(sBrowser))
            {
                sBrowser = "C:\\Program Files\\Mozilla Firefox\\firefox.exe";
            }
            if (!File.Exists(sBrowser))
            {
                sBrowser = "C:\\Programme\\Mozilla Firefox\\firefox.exe";
            }
            execute(sBrowser,false);
        }

        private void BnOpera_Click(object sender, EventArgs e)
        {
            string sBrowser = "C:\\Program Files (x86)\\Opera\\opera.exe";
            if (!File.Exists(sBrowser))
            {
                sBrowser = "C:\\Program Files\\Opera\\opera.exe";
            }
            if (!File.Exists(sBrowser))
            {
                sBrowser = "C:\\Programme\\Opera\\opera.exe";
            }
            execute(sBrowser, false);
        }

        private void BnChrome_Click(object sender, EventArgs e)
        {
            string sBrowser = "chrome.exe";
            execute(sBrowser, false);
        }

        private void BnIExplorer_Click(object sender, EventArgs e)
        {
            // C:\Program Files (x86)\Internet Explorer

            string sBrowser = "iexplore.exe";
            execute(sBrowser, false);
        }

        private void MnBrowser5_Click(object sender, EventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            if (File.Exists(singvar.Broswer5))
                execute(singvar.Broswer5, false);
            else
                MessageBox.Show("Der 5. Browser ist nicht vorhanden", "Hinweis",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information);
        }

        private void MnBrowser6_Click(object sender, EventArgs e)
        {
            SingVar singvar = SingVar.getInstance();
            if (File.Exists(singvar.Broswer6))
                execute(singvar.Broswer6, false);
            else
                MessageBox.Show("Der 6. Browser ist nicht vorhanden", "Hinweis",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information);
        }


        private void execute(string sBrowser, bool bStandard)
        {
            if (!sBrowser.StartsWith("\"") && !sBrowser.EndsWith("\""))
            {
                sBrowser = "\"" + sBrowser + "\"";
            }
            Form form = this.ActiveMdiChild;
            if (form!=null)
            {
                ChildForm child = (ChildForm) form;
                child.save();
                string sFilename = (child).Filename;                

                if (Basis.getFilenameExt(sFilename).Equals("css"))
                {
                    // suche html-child
                    sFilename = Basis.changeFilenameExt(sFilename, "xhtml");
                    foreach (Form childForm in MdiChildren)
                    {
                        ChildForm panel = ((ChildForm)childForm);
                        if (panel.Filename.Equals(sFilename,StringComparison.CurrentCultureIgnoreCase)) {
                            panel.save();
                            break;
                        }
                    }  // foreach (TabPage page in tabControl1.TabPages)
                }
                Process Prog = new Process();
                if (bStandard)
                {
                    Prog.StartInfo.FileName = "\""+sFilename + "\"";
                    Prog.StartInfo.Arguments = "";
                }
                else
                {
                    Prog.StartInfo.FileName = sBrowser;
                    Prog.StartInfo.Arguments = "\"" + sFilename + "\"";
                }
                Prog.Start();
            }
        }

        private void MnStandardBrowser_Click(object sender, EventArgs e)
        {
            execute("", true);
        }







        
    }
}
