﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Windows.Forms;

using System.IO;

using ScintillaNET;



namespace html
{
    class RegPanel : Panel
    {
        public const int MenueTyp_NONE = 0;
        public const int MenueTyp_HTML = 1;
        public const int MenueTyp_CSS  = 2;

        private int menueTyp = MenueTyp_NONE;

        public int MenueTyp
        {
            get { return menueTyp; }
        }

        private String sFileShort;

        private ScintillaNET.Scintilla scintilla;

        private String sFilename = null;

        public string Filename
        {
            get { return sFilename; }
        }

        public bool isModify
        {
            get { return scintilla.Modified; }
            set { scintilla.Modified = value; }
        }

        public ScintillaNET.Scintilla Scintilla
        {
            get { return this.scintilla; }
        }

        
        public RegPanel(String sFilename, int MenueTyp)
        {
            this.menueTyp = MenueTyp;
            this.sFilename = sFilename;            
            sFileShort = Basis.getFilename(sFilename);
            
            scintilla = new ScintillaNET.Scintilla();
            // Sci_Middleware instance = Sci_Middleware.getInstance();
            Sci_Middleware.initSci(ref scintilla);

            this.Controls.Add(this.scintilla);

            //scintilla.ConfigurationManager.Language = "html";

            if (sFilename != null)
            {
                //  Text = sFilename;
                Sci_Middleware.setLanguage_intern(ref scintilla, sFilename);
                if (File.Exists(sFilename))
                    scintilla.Text = File.ReadAllText(sFilename);
                else
                    scintilla.Text = "";
                scintilla.Modified = false;
            }
            else
            {
                Text = SingVar.C_NONAME;
                scintilla.ConfigurationManager.Language = "html";
            }
            scintilla.Update();
            //scintilla.AppendText("xxxx");
            int pos = scintilla.CurrentPos;  // Cahracter Position im gesamten Text
            
            // scintilla.Indentation.IndentWidth = 4;  // ??
            //scintilla.InsertText(pos, "ancde\r\n");
            scintilla.Invalidate();
            //scintilla.Lexing.

            LineCollection l = scintilla.Lines;

            foreach (Line s in l)
            {
               //   MessageBox.Show(s.Text);
            }
            LongLines ll = scintilla.LongLines;
            byte [] t = scintilla.RawText;
            //scintilla.Scale(
            string tt = scintilla.Text;
            //scintilla.

            scintilla.ModifiedChanged += new System.EventHandler(scintilla_ModifiedChanged);

        } // HTMLPanel

        public void setLanguage(string lang)
        {
            scintilla.ConfigurationManager.Language = lang;
            scintilla.Invalidate(true);
            scintilla.Update();
        }


        private void scintilla_ModifiedChanged(object sender, EventArgs e)
        {
            Parent.Text = sFileShort + " *";
            // MessageBox.Show("modify");
        }



        public void save()
        {
            using (
                FileStream fs = File.Create(sFilename)
            )
            using (
                BinaryWriter bw = new BinaryWriter(fs)
            )
            bw.Write(scintilla.RawText, 0, scintilla.RawText.Length - 1); // Omit trailing NULL

            scintilla.Modified = false;
            Parent.Text = sFileShort;
        }

        public void saveAs(string sFilename)
        {
            this.sFilename = sFilename;
            save();
        }



        public void Close()
        {
        }

        //---------------


        public void setWhiteSpace(bool bWhitespace)
        {
            if (bWhitespace)
                scintilla.Whitespace.Mode = WhitespaceMode.VisibleAlways;
            else
                scintilla.Whitespace.Mode = WhitespaceMode.Invisible;

        }

        public void setMnEndOfLine(bool bEndOfLine)
        {
            scintilla.EndOfLine.IsVisible = bEndOfLine;
        }



        public void setLineNumbers(bool bLineNumbers)
        {
            if (bLineNumbers)
                scintilla.Margins.Margin0.Width = 35; // LINE_NUMBERS_MARGIN_WIDTH;
            else
                scintilla.Margins.Margin0.Width = 0;
        }


        public void setWordWrap(bool bWordWrap)
        {
            if (bWordWrap)
                scintilla.LineWrapping.Mode = LineWrappingMode.Word;
            else
                scintilla.LineWrapping.Mode = LineWrappingMode.None;
        }


        public void setZoom(int zoomLevel)
        {
            scintilla.Zoom = zoomLevel;
            if (scintilla.LineWrapping.Mode != LineWrappingMode.None)
            {
                if (zoomLevel < 10)
                    scintilla.Margins.Margin0.Width = (int)(40 + zoomLevel / 2);
                else
                    if (zoomLevel < 18)
                        scintilla.Margins.Margin0.Width = (int)(40 + (zoomLevel + 15) / 1.7);
                    else
                        scintilla.Margins.Margin0.Width = (int)(40 + (zoomLevel + 25) / 1.7);
            }
        }


        public void setTabLength(int tabLength)
        {
            scintilla.Indentation.TabWidth = tabLength;
        }


        public void search()
        {
            scintilla.FindReplace.ShowFind();
        }


        public void searchreplace()
        {
            scintilla.FindReplace.ShowReplace();
        }

        public void MakeUpper()
        {
            scintilla.Commands.Execute(BindableCommand.UpperCase);
        }

        public void MakeLower()
        {
            scintilla.Commands.Execute(BindableCommand.LowerCase);
        }

        public void CommentRange()
        {
            scintilla.Commands.Execute(BindableCommand.StreamComment);
        }

        public void CommentLine()
        {
            scintilla.Commands.Execute(BindableCommand.LineComment);
        }
        public void UnCommentLine()
        {
            scintilla.Commands.Execute(BindableCommand.LineUncomment);
        }


        public void AutoComplete()
        {
            scintilla.AutoComplete.Show();
        }

        public void InsertSnippet()
        {
            scintilla.Snippets.ShowSnippetList();
        }


        public void SurroundWithSnippets()
        {
            scintilla.Snippets.ShowSurroundWithList();
        }

        public void ShowGoto()
        {
            scintilla.GoTo.ShowGoToDialog();
        }




        public void ToggleBookmarks()
        {
            Line currentLine = scintilla.Lines.Current;
            if (scintilla.Markers.GetMarkerMask(currentLine) == 0)
            {
                currentLine.AddMarker(0);
            }
            else
            {
                currentLine.DeleteMarker(0);
            }
        }


        public void PreviousMarker()
        {
            //	 I've got to redo this whole FindNextMarker/FindPreviousMarker Scheme
            Line l = scintilla.Lines.Current.FindPreviousMarker(1);
            if (l != null)
                l.Goto();
        }
        public void NextMarker()
        {
            //	 I've got to redo this whole FindNextMarker/FindPreviousMarker Scheme
            Line l = scintilla.Lines.Current.FindNextMarker(1);
            if (l != null)
                l.Goto();
        }
        public void ClearMarker()
        {
            scintilla.Markers.DeleteAll(0);
        }


        public void DropMarker()
        {
            scintilla.DropMarkers.Drop();
        }
        public void CollectMarker()
        {
            scintilla.DropMarkers.Collect();
        }


        public void undo()
        {
            scintilla.UndoRedo.Undo();
        }
        public void redo()
        {
            scintilla.UndoRedo.Redo();
        }


        public void cut()
        {
            scintilla.Clipboard.Cut();
        }
        public void copy()
        {
            scintilla.Clipboard.Copy();
        }
        public void paste()
        {
            scintilla.Clipboard.Paste();
        }
        public void selectAll()
        {
            scintilla.Selection.SelectAll();
        }

        public void PrintPreview()
        {
            scintilla.Printing.PrintPreview();
        }
        public void Print()
        {
            scintilla.Printing.Print();
        }


        public void FoldLevel()
        {
            scintilla.Lines.Current.FoldExpanded = true;
        }

        public void UnfoldLevel()
        {
            scintilla.Lines.Current.FoldExpanded = false;
        }

        public void FoldAll()
        {
            foreach (Line l in scintilla.Lines)
            {
                l.FoldExpanded = true;
            }
        }

        public void UnfoldAll()
        {
            foreach (Line l in scintilla.Lines)
            {
                l.FoldExpanded = false;
            }
        }

        public void NavigateForward()
        {
            scintilla.DocumentNavigation.NavigateForward();
        }

        public void NavigateBackward()
        {
            scintilla.DocumentNavigation.NavigateBackward();
        }

        public void InsertHTML_HTML5_strict11() {
            Sci_Middleware.InsertHTML_HTML5_strict11(scintilla);
        }

        // HTML - Funktionen 
        public void InsertHTML_Basic_XHTML_strict11()
        {
            Sci_Middleware.InsertHTML_Basic_XHTML_strict11(scintilla);
        }



        public void InsertHTML_Basic_XHTML()
        {
            Sci_Middleware.InsertHTML_Basic_XHTML(scintilla);
        }

        public void InsertBasic_HTML4()
        {
            Sci_Middleware.InsertHTML_HTML4(scintilla);
        }

        public void InsertHTML_Basic_Pur()
        {
            Sci_Middleware.InsertHTML_Basic_Pur(scintilla);
        }


        public void InsertHTML_Header()
        {
            Sci_Middleware.InsertHTML_Header(scintilla);
        }

        public void InsertHTML_Paragraph()
        {
            Sci_Middleware.InsertHTML_Paragraph(scintilla);
        }

        public void InsertHTML_Header3()
        {
            Sci_Middleware.InsertHTML_Header3(scintilla);
        }

        public void InsertHTML_UL()
        {
            Sci_Middleware.InsertHTML_UL(scintilla);
        }

        public void InsertHTML_OL()
        {
            Sci_Middleware.InsertHTML_OL(scintilla);
        }

        public void InsertHTML_Table()
        {
            Sci_Middleware.InsertHTML_Table(scintilla);
        }

        public void InsertHTML_TR()
        {
            Sci_Middleware.InsertHTML_TR(scintilla);
        }

        public void InsertHTML_HR()
        {
            Sci_Middleware.InsertHTML_HR(scintilla);
        }

        public void InsertCSS_FontColor()
        {
            Sci_Middleware.InsertCSS_FontColor(scintilla);
        }

        public void InsertCSS_ColorConstant()
        {
            Sci_Middleware.InsertCSS_ColorConstant(scintilla);
        }

        public void InsertHTML_EMailLink()
        {
            Sci_Middleware.InsertHTML_EMailLink(scintilla);
        }

        public void InsertHTML_Link()
        {
            Sci_Middleware.InsertHTML_Link(scintilla);
        }

        public void InsertHTML_Anchor()
        {
            Sci_Middleware.InsertHTML_Anchor(scintilla);
        }

        public void InsertHTML_Comment()
        {
            Sci_Middleware.InsertHTML_Comment(scintilla);
        }

        public void InsertHTML_InsertImage()
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.DefaultExt = ".bmp";
            openFileDialog.InitialDirectory = System.Environment.CurrentDirectory; //  Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            openFileDialog.Filter =   "BMP-Dateien (*.bmp)|*.bmp|"+
                                      "JPG-Dateien (*.jpg;*.jpeg)|*.jpg;*.jpeg|" +
                                      "GIF-Dateien (*.gif)|*.gif|" +
                                      "PING-Dateien (*.png)|*.png|Alle Dateien (*.*)|*.*";

            openFileDialog.Multiselect = true;
            openFileDialog.Title = "Bildatei Öffnen";



            if (openFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                // openFileDialog.FileName
                if (Basis.readYesNo("Wollen Sie zusätzliche Koordinatenbereiche als Links einfügen?", "Area Shapes"))
                    Sci_Middleware.InsertHTML_InsertImage(scintilla, openFileDialog.FileName, true);
                else
                    Sci_Middleware.InsertHTML_InsertImage(scintilla, openFileDialog.FileName, false);
            }
        }



        public void InsertImageCoords()
        {
              Sci_Middleware.InsertImageCoords(scintilla);
        }

        public void InsertImageCoordsFromSHWFile()
        {
            Sci_Middleware.InsertImageCoordsFromSHWFile(scintilla);
        }

        public void InsertHTML_Font_Bold()
        {
            Sci_Middleware.InsertHTML_Font_Bold(scintilla);
        }

        public void InsertHTML_Font_Italic()
        {
            Sci_Middleware.InsertHTML_Font_Italic(scintilla);
        }

        public void InsertHTML_Font_Underline()
        {
            Sci_Middleware.InsertHTML_Font_Underline(scintilla);
        }

        public void InsertHTML_Font_LineThrough()
        {
            Sci_Middleware.InsertHTML_Font_LineThrough(scintilla);
        }

        public void InsertHTML_Font_Sup()
        {
            Sci_Middleware.InsertHTML_Font_Sup(scintilla);
        }

        public void InsertHTML_Font_Sub()
        {
            Sci_Middleware.InsertHTML_Font_Sub(scintilla);
        }

        public void InsertHTML_Font_Char_Space()
        {
            Sci_Middleware.InsertHTML_Font_Char_Space(scintilla);
        }

        public void InsertHTML_Font_Char_Tab()
        {
            Sci_Middleware.InsertHTML_Font_Char_Tab(scintilla);
        }

        public void InsertHTML_Font_Char_CR()
        {
            Sci_Middleware.InsertHTML_Font_Char_CR(scintilla);
        }

        public void InsertHTML_Font_Char_LF()
        {
            Sci_Middleware.InsertHTML_Font_Char_LF(scintilla);
        }

        public void InsertHTML_Font_Char_Blank()
        {
            Sci_Middleware.InsertHTML_Font_Char_Blank(scintilla);
        }

        public void InsertHTML_Font_Char_Dash()
        {
            Sci_Middleware.InsertHTML_Font_Char_Dash(scintilla);
        }

        public void InsertHTML_Font_Char_Copyright()
        {
            Sci_Middleware.InsertHTML_Font_Char_Copyright(scintilla);
        }

        public void InsertHTML_Font_Char_Copyright_R()
        {
            Sci_Middleware.InsertHTML_Font_Char_Copyright_R(scintilla);
        }

        public void InsertHTML_Font_Char_Trademark()
        {
            Sci_Middleware.InsertHTML_Font_Char_Trademark(scintilla);
        }

        public void InsertHTML_Font_Char_LT()
        {
            Sci_Middleware.InsertHTML_Font_Char_LT(scintilla);
        }

        public void InsertHTML_Font_Char_GT()
        {
            Sci_Middleware.InsertHTML_Font_Char_GT(scintilla);
        }

        public void InsertHTML_Font_Char_GTGT()
        {
            Sci_Middleware.InsertHTML_Font_Char_GTGT(scintilla);
        }

        public void InsertHTML_Font_Char_LTLT()
        {
            Sci_Middleware.InsertHTML_Font_Char_LTLT(scintilla);
        }



        public void InsertHTML_CSSReferenzExtern()
        {
            Sci_Middleware.InsertHTML_CSSReferenzExtern(scintilla);
        }

        public void InsertHTML_CSSReferenzLocal()
        {
            Sci_Middleware.InsertHTML_CSSReferenzLocal(scintilla);
        }

        public void InsertCSS_Body()
        {
            Sci_Middleware.InsertCSS_Body(scintilla);
        }

        public void Insert_CSSBlock()
        {
            Sci_Middleware.InsertCSS_xx(scintilla);
        }

        public void Insert_CSSBlock_H2()
        {
            Sci_Middleware.InsertCSS_H2(scintilla);
        }

        public void Insert_CSSBlock_OL()
        {
            Sci_Middleware.InsertCSS_OL(scintilla);
        }

        public void Insert_CSSBlock_UL()
        {
            Sci_Middleware.InsertCSS_UL(scintilla);
        }

        public void Insert_CSSBlock_TH()
        {
            Sci_Middleware.InsertCSS_TH(scintilla);
        }

        public void Insert_CSSBlock_TD()
        {
            Sci_Middleware.InsertCSS_TD(scintilla);
        }

        public void InsertHTML_Scrolling()
        {
            Sci_Middleware.InsertHTML_Scrolling(scintilla);
        }

        public void InsertCSS_background_image()
        {
            Sci_Middleware.InsertCSS_background_image(scintilla);
        }

        public void InsertCSS_Body_backgroundrepeat()
        {
            Sci_Middleware.InsertCSS_Body_backgroundrepeat(scintilla);
        }

        public void InsertCSS_Bodybackgroundattachment()
        {
            Sci_Middleware.InsertCSS_Bodybackgroundattachment(scintilla);
        }

        public void InsertCSS_Body_backgroundposition()
        {
            Sci_Middleware.InsertCSS_Body_backgroundposition(scintilla);
        }

        public void InsertCSS_FarbeKonstante()
        {
            Sci_Middleware.InsertCSS_ColorConstant(scintilla);
        }

        public void InsertCSS_Farbe()
        {
           Sci_Middleware.InsertCSS_FontColor(scintilla);
        }

        public void Insert_CSS_Backgroundcolor()
        {
            Sci_Middleware.InsertCSS_BackgroundColor(scintilla);
        }

        public void InsertCSS_FontSize()
        {
            Sci_Middleware.InsertCSS_FontSize_12em(scintilla);
        }


        public void InsertCSS_Fonttyp_Verdana()
        {
            Sci_Middleware.InsertCSS_Fonttyp_Verdana(scintilla);
        }

        public void InsertCSS_Fonttyp_CourierNew()
        {
            Sci_Middleware.InsertCSS_Fonttyp_CourierNew(scintilla);
        }

        public void InsertCSS_Fonttyp_Monospace()
        {
            Sci_Middleware.InsertCSS_Fonttyp_Monospace(scintilla);
        }

        public void InsertCSS_SmallestFont()
        {
            Sci_Middleware.InsertCSS_SmallestFont(scintilla);
        }

        public void InsertCSS_SmallerFont()
        {
            Sci_Middleware.InsertCSS_SmallerFont(scintilla);
        }

        public void InsertCSS_FontGreater()
        {
            Sci_Middleware.InsertCSS_BiggerFont(scintilla);
        }

        public void InsertCSS_GreatestFont()
        {
            Sci_Middleware.InsertCSS_BigFont(scintilla);
        }

        public void InsertCSS_FonzSizeEm()
        {
            Sci_Middleware.InsertCSS_FontSize_15Em(scintilla);
        }

        public void InsertCSS_Bigger_Percentage()
        {
            Sci_Middleware.InsertCSS_Bigger_Percentage(scintilla);
        }

        public void InsertCSS_WordSpacing()
        {
            Sci_Middleware.InsertCSS_WordSpacing(scintilla);
        }

        public void InsertCSS_LetterSpacing()
        {
            Sci_Middleware.InsertCSS_LetterSpacing(scintilla);
        }

        public void InsertCSS_Textdecoration_None()
        {
            Sci_Middleware.InsertCSS_Textdecoration_None(scintilla);
        }

        public void InsertCSS_Textdecoration_Underline()
        {
            Sci_Middleware.InsertCSS_Textdecoration_Underline(scintilla);
        }

        public void InsertCSS_Textdecoration_Overline()
        {
            Sci_Middleware.InsertCSS_Textdecoration_Overline(scintilla);
        }

        public void InsertCSS_Textdecoration_Linethrough()
        {
            Sci_Middleware.InsertCSS_Textdecoration_linethrough(scintilla);
        }

        public void InsertCSS_Textdecoration_Blinkend()
        {
            Sci_Middleware.InsertCSS_Textdecoration_blink(scintilla);
        }

        public void InsertCSS_Textdecoration_Italic()
        {
            Sci_Middleware.InsertCSS_Textdecoration_Italic(scintilla);
        }

        public void InsertCSS_Texttransform_None()
        {
            Sci_Middleware.InsertCSS_TextTransform_none(scintilla);
        }

        public void InsertCSS_Texttransform_Uppercase()
        {
            Sci_Middleware.InsertCSS_TextTransform_uppercase(scintilla);
        }

        public void InsertCSS_Texttransform_Lowercase()
        {
            Sci_Middleware.InsertCSS_TextTransform_lowercase(scintilla);
        }

        public void InsertCSS_Texttransform_Capitalize()
        {
            Sci_Middleware.InsertCSS_TextTransform_capitalize(scintilla);
        }

        public void InsertCSS_textindent()
        {
            Sci_Middleware.InsertCSS_Text_Indent(scintilla);
        }

        public void CSS_Lists_UL_None()
        {
            Sci_Middleware.InsertCSS_UL_listeNone(scintilla);
        }

        public void CSS_Lists_UL_Circle()
        {
            Sci_Middleware.InsertCSS_UL_Listecircle(scintilla);
        }

        public void CSS_Lists_UL_Square()
        {
            Sci_Middleware.InsertCSS_UL_Listesquare(scintilla);
        }

        public void c()
        {
            Sci_Middleware.InsertCSS_UL_Listedisc(scintilla);
        }

        public void CSS_Lists_OL_None()
        {
            Sci_Middleware.InsertCSS_OL_ListeNone(scintilla);
        }

        public void CSS_Lists_OL_Decimal()
        {
            Sci_Middleware.InsertCSS_OL_Listedecimal(scintilla);
        }

        public void CSS_Lists_OL_Decimalleadingzero()
        {
            Sci_Middleware.InsertCSS_OL_Listedecimalleadingzero(scintilla);
        }

        public void CSS_Lists_OL_Lowerroman()
        {
            Sci_Middleware.InsertCSS_OL_Listelowerroman(scintilla);
        }

        public void CSS_Lists_OL_Upperroman()
        {
            Sci_Middleware.InsertCSS_OL_Listeupperroman(scintilla);
        }

        public void CSS_Lists_OL_Lowergreek()
        {
            Sci_Middleware.InsertCSS_OL_Listelowergreek(scintilla);
        }

        public void CSS_Lists_OL_Uppergreek()
        {
            Sci_Middleware.InsertCSS_OL_Listeuppergreek(scintilla);
        }

        public void CSS_Lists_OL_Lowerlatin()
        {
            Sci_Middleware.InsertCSS_OL_Listelowerlatin(scintilla);
        }

        public void CSS_Lists_OL_Upperlatin()
        {
            Sci_Middleware.InsertCSS_OL_ListeUpperlatin(scintilla);
        }

        public void CSS_Lists_Inside()
        {
            Sci_Middleware.InsertCSS_ListStylePosition_inside(scintilla);
        }

        public void CSS_Lists_Outside()
        {
            Sci_Middleware.InsertCSS_ListStylePosition_outside(scintilla);
        }

        public void InsertCSS_TH()
        {
            Sci_Middleware.InsertCSS_BlockTH(scintilla);
        }

        public void InsertCSS_TD()
        {
            Sci_Middleware.InsertCSS_BlockTD(scintilla);
        }

        public void InsertCSS_Table_th_td_Border()
        {
            Sci_Middleware.InsertCSS_TableBorderTDTHTable(scintilla);
        }

        public void InsertCSS_BorderColor()
        {
            Sci_Middleware.InsertCSS_Bordercolor(scintilla);
        }

        public void InsertCSS_Border_None()
        {
            Sci_Middleware.InsertCSS_BorderStyleNone(scintilla);
        }

        public void InsertCSS_Border_Hidden()
        {
            Sci_Middleware.InsertCSS_BorderStyleHidden(scintilla);
        }

        public void InsertCSS_Border_Dotted()
        {
            Sci_Middleware.InsertCSS_BorderStyleDotted(scintilla);
        }

        public void InsertCSS_Border_Dashed()
        {
            Sci_Middleware.InsertCSS_BorderStyleDashed(scintilla);
        }

        public void InsertCSS_Border_Solid()
        {
            Sci_Middleware.InsertCSS_BorderStyleSolid(scintilla);
        }

        public void InsertCSS_Border_Double()
        {
            Sci_Middleware.InsertCSS_BorderStyleDouble(scintilla);
        }

        public void InsertCSS_Border_Groove()
        {
            Sci_Middleware.InsertCSS_BorderStyleGroove(scintilla);
        }

        public void InsertCSS_Border_Ridge()
        {
            Sci_Middleware.InsertCSS_BorderStyleRidge(scintilla);
        }

        public void InsertCSS_Border_Inset()
        {
            Sci_Middleware.InsertCSS_BorderStyleInset(scintilla);
        }

        public void InsertCSS_Border_Outset()
        {
            Sci_Middleware.InsertCSS_BorderStyleOutset(scintilla);
        }

        public void InsertCSS_BorderWidth()
        {
            Sci_Middleware.InsertCSS_BorderWidth(scintilla);
        }

        public void InsertCSS_Padding_OneForFour()
        {
            Sci_Middleware.InsertCSS_PaddingOneForfour(scintilla);
        }

        public void InsertCSS_Padding_TwoForTwo()
        {
            Sci_Middleware.InsertCSS_PaddingTwoForTwo(scintilla);
        }

        public void InsertCSS_Padding_FourForFour()
        {
            Sci_Middleware.InsertCSS_PaddingFourForFour(scintilla);
        }

        public void InsertCSS_Padding_Top()
        {
            Sci_Middleware.InsertCSS_PaddingTop(scintilla);
        }

        public void InsertCSS_Padding_Left()
        {
            Sci_Middleware.InsertCSS_PaddingLeft(scintilla);
        }

        public void InsertCSS_Padding_Bottom()
        {
            Sci_Middleware.InsertCSS_PaddingBottom(scintilla);
        }

        public void InsertCSS_Padding_Right()
        {
            Sci_Middleware.InsertCSS_Paddingright(scintilla);
        }

        public void InsertCSS_Margin_OneForFour()
        {
            Sci_Middleware.InsertCSS_MarginOneForFour(scintilla);
        }

        public void InsertCSS_Margin_TwoForTwo()
        {
            Sci_Middleware.InsertCSS_MarginTwoForTwo(scintilla);
        }

        public void InsertCSS_Margin_FourForFour()
        {
            Sci_Middleware.InsertCSS_MarginFourForFour(scintilla);
        }

        public void InsertCSS_Margin_Top()
        {
            Sci_Middleware.InsertCSS_MarginTop(scintilla);
        }

        public void InsertCSS_Margin_Left()
        {
            Sci_Middleware.InsertCSS_MarginLeft(scintilla);
        }

        public void InsertCSS_Margin_Bottom()
        {
            Sci_Middleware.InsertCSS_MarginBottom(scintilla);
        }

        public void InsertCSS_Margin_Right()
        {
            Sci_Middleware.InsertCSS_MarginRight(scintilla);
        }

        public void InsertCSS_Links_NoneVisited()
        {
            Sci_Middleware.InsertCSS_Links_NoneVisited(scintilla);
        }

        public void InsertCSS_Links_Visited()
        {
            Sci_Middleware.InsertCSS_Links_Visited(scintilla);
        }

        public void InsertCSS_Links_Activate()
        {
            Sci_Middleware.InsertCSS_Links_Activate(scintilla);
        }

        public void InsertCSS_Links_ThreeLinks()
        {
            Sci_Middleware.InsertCSS_Links_ThreeLinks(scintilla);
        }

        public void InsertCSS_Links_ThreeLinksTogether()
        {
            Sci_Middleware.InsertCSS_Links_ThreeLinksTogether(scintilla);
        }


        public void InsertCSS_Textalign_left()
        {
            Sci_Middleware.InsertCSS_Textalign_left(scintilla);
        }

        public void InsertCSS_Textalign_center()
        {
            Sci_Middleware.InsertCSS_Textalign_center(scintilla);
        }

        public void InsertCSS_Textalign_right()
        {
            Sci_Middleware.InsertCSS_Textalign_right(scintilla);
        }

        public void InsertCSS_Textalign_justify()
        {
            Sci_Middleware.InsertCSS_Textalign_justify(scintilla);
        }

        public void InsertCSS_Valign_baseline()
        {
            Sci_Middleware.InsertCSS_Valign_baseline(scintilla);
        }

        public void InsertCSS_Valign_Sub()
        {
            Sci_Middleware.InsertCSS_Valign_Sub(scintilla);
        }

        public void InsertCSS_Valign_Super()
        {
            Sci_Middleware.InsertCSS_Valign_Super(scintilla);
        }

        public void InsertCSS_Valign_texttop()
        {
            Sci_Middleware.InsertCSS_Valign_texttop(scintilla);
        }

        public void InsertCSS_Valign_textbottom()
        {
            Sci_Middleware.InsertCSS_Valign_textbottom(scintilla);
        }

        public void InsertCSS_Valign_middle()
        {
            Sci_Middleware.InsertCSS_Valign_middle(scintilla);
        }

        public void InsertCSS_Valign_top()
        {
            Sci_Middleware.InsertCSS_Valign_top(scintilla);
        }

        public void InsertCSS_Valign_bottom()
        {
            Sci_Middleware.InsertCSS_Valign_bottom(scintilla);
        }

        public void InsertCSS_Valign_percentage()
        {
            Sci_Middleware.InsertCSS_Valign_percentage(scintilla);
        }

        public void InsertCSS_FieldsetLegend()
        {
            Sci_Middleware.InsertCSS_FieldsetLegend(scintilla);
        }


        public void InsertHTML5_Header() {
            Sci_Middleware.InsertHTML5_Header(scintilla);
        }

        public void InsertHTML5_Nav() {
            Sci_Middleware.InsertHTML5_Nav(scintilla);
        }

        public void InsertHTML5_Section() {
            Sci_Middleware.InsertHTML5_Section(scintilla);
        }


        public void InsertHTML5_Aside() {
            Sci_Middleware.InsertHTML5_Aside(scintilla);
        }

        public void InsertHTML5_Footer() {
            Sci_Middleware.InsertHTML5_Footer(scintilla);
        }




        public void InsertForm_Formrange1()
        {
            Sci_Middleware.InsertForm_Formrange1(scintilla);
        }

        public void InsertForm_Formrange2() {
            Sci_Middleware.InsertForm_Formrange2(scintilla);
        }

        public void InsertForm_FieldsetLegend()
        {
            Sci_Middleware.InsertForm_FieldsetLegend(scintilla);
        }

        public void InsertForm_Label()
        {
            Sci_Middleware.InsertForm_Label(scintilla);
        }

        public void InsertForm_Textfeld1()
        {
            Sci_Middleware.InsertForm_Textfeld1(scintilla);
        }
        public void InsertForm_Textfeld2() {
            Sci_Middleware.InsertForm_Textfeld2(scintilla);
        }

        public void InsertForm_TextfeldPattern()
        {
            Sci_Middleware.InsertForm_TextfeldPattern(scintilla);
        }

        public void InsertForm_Textarea()
        {
            Sci_Middleware.InsertForm_Textarea(scintilla);
        }

        public void InsertForm_Hidden()
        {
            Sci_Middleware.InsertForm_Hidden(scintilla);
        }

        public void InsertForm_CheckBox()
        {
            Sci_Middleware.InsertForm_CheckBox(scintilla);
        }

        public void InsertForm_RadioButton()
        {
            Sci_Middleware.InsertForm_RadioButton(scintilla);
        }

        public void InsertForm_ComboBox()
        {
            Sci_Middleware.InsertForm_ComboBox(scintilla);
        }

        public void InsertForm_HTML5_Number()
        {
            Sci_Middleware.InsertForm_HTML5_Number(scintilla);
        }

        public void InsertForm_HTML5_Range()
        {
            Sci_Middleware.InsertForm_HTML5_Range(scintilla);
        }

        public void InsertForm_HTML5_Color()
        {
            Sci_Middleware.InsertForm_HTML5_Color(scintilla);
        }

        public void InsertForm_HTML5_Date()
        {
            Sci_Middleware.InsertForm_HTML5_Date(scintilla);
        }



        public void InsertForm_HTML5_Header()
        {
            Sci_Middleware.InsertForm_HTML5_Header(scintilla);
        }
        public void InsertForm_HTML5_Arcticle()
        {
            Sci_Middleware.InsertForm_HTML5_Arcticle(scintilla);
        }
        public void InsertForm_HTML5_Section()
        {
            Sci_Middleware.InsertForm_HTML5_Section(scintilla);
        }
        public void InsertForm_HTML5_Aside() {
            Sci_Middleware.InsertForm_HTML5_Aside(scintilla);
        }
        public void InsertForm_HTML5_Footer() {
            Sci_Middleware.InsertForm_HTML5_Footer(scintilla);
        }
        public void InsertForm_HTML5_Progess() {
            Sci_Middleware.InsertForm_HTML5_Progess(scintilla);
        }
        public void InsertForm_HTML5_Datetime() {
            Sci_Middleware.InsertForm_HTML5_Datetime(scintilla);
        }
        public void InsertForm_HTML5_Address() {
            Sci_Middleware.InsertForm_HTML5_Address(scintilla);
        }
        public void InsertForm_HTML5_Summary() {
            Sci_Middleware.InsertForm_HTML5_Summary(scintilla);
        }
        public void InsertForm_HTML5_Details() {
            Sci_Middleware.InsertForm_HTML5_Details(scintilla);
        }
        public void InsertForm_HTML5_Audio() {
            Sci_Middleware.InsertForm_HTML5_Audio(scintilla);
        }
        public void InsertForm_HTML5_Video() {
            Sci_Middleware.InsertForm_HTML5_Video(scintilla);
        }


        public void InsertForm_HTML5_Meter() {
            Sci_Middleware.InsertForm_HTML5_Meter(scintilla);
        }

        public void InsertForm_HTML5_Canvas() {
            Sci_Middleware.InsertForm_HTML5_Canvas(scintilla);
        }

        public void InsertForm_HTML5_Output() {
            Sci_Middleware.InsertForm_HTML5_Output(scintilla);
        }



        public void InsertForm_HTML5_Wbr() {
            Sci_Middleware.InsertForm_HTML5_Wbr(scintilla);
            
        }
        public void InsertForm_HTML5_S() {
            Sci_Middleware.InsertForm_HTML5_S(scintilla);
        }
        public void InsertForm_HTML5_Hr() {
            Sci_Middleware.InsertForm_HTML5_Hr(scintilla);
        }
        public void InsertForm_HTML5_Strong() {
            Sci_Middleware.InsertForm_HTML5_Strong(scintilla);
        }
        public void InsertForm_HTML5_Small() {
            Sci_Middleware.InsertForm_HTML5_Small(scintilla);
        }
        public void InsertForm_HTML5_Em() {
            Sci_Middleware.InsertForm_HTML5_Em(scintilla);
        }
        public void InsertForm_HTML5_Abbr() {
            Sci_Middleware.InsertForm_HTML5_Abbr(scintilla);
        }
        public void InsertForm_HTML5_Code() {
            Sci_Middleware.InsertForm_HTML5_Code(scintilla);
        }
        public void InsertForm_HTML5_Var() {
            Sci_Middleware.InsertForm_HTML5_Var(scintilla);
        }
        public void InsertForm_HTML5_Cite() {
            Sci_Middleware.InsertForm_HTML5_Cite(scintilla);
        }
        public void InsertForm_HTML5_Dl() {
            Sci_Middleware.InsertForm_HTML5_Dl(scintilla);
        }
        public void InsertForm_HTML5_Dfn() {
            Sci_Middleware.InsertForm_HTML5_Dfn(scintilla);
        }



        public void InsertForm_Submit()
        {
            Sci_Middleware.InsertForm_Submit(scintilla);
        }

        public void InsertForm_Button()
        {
            Sci_Middleware.InsertForm_Button(scintilla);
        }

        public void InsertForm_Reset()
        {
            Sci_Middleware.InsertForm_Reset(scintilla);
        }


        public void InsertForm_CompletSample()
        {
            Sci_Middleware.InsertForm_CompletSample(scintilla);
        }




        public void InsertJavaScript_InsertRange()
        {
            Sci_Middleware.InsertJavaScript_InsertRange(scintilla);
        }

        public void InsertJavaScript_Function()
        {
            Sci_Middleware.InsertJavaScript_Function(scintilla);
        }

        public void InsertJavaScript_Consolelog()
        {
            Sci_Middleware.InsertJavaScript_Consolelog(scintilla);
        }

        public void InsertJavaScript_Event_onload()
        {
            Sci_Middleware.InsertJavaScript_Event_onload(scintilla);
        }

        public void InsertJavaScript_Event_onUnload()
        {
            Sci_Middleware.InsertJavaScript_Event_onUnload(scintilla);
        }

        public void InsertJavaScript_Event_onClick()
        {
            Sci_Middleware.InsertJavaScript_Event_onClick(scintilla);
        }

        public void InsertJavaScript_onDblclick()
        {
            Sci_Middleware.InsertJavaScript_onDblclick(scintilla);
        }

        public void InsertJavaScript_Event_onMouseDown()
        {
            Sci_Middleware.InsertJavaScript_Event_onMouseDown(scintilla);
        }

        public void InsertJavaScript_Event_onMouseUp()
        {
            Sci_Middleware.InsertJavaScript_Event_onMouseUp(scintilla);
        }

        public void InsertJavaScript_Event_onMouseOver()
        {
            Sci_Middleware.InsertJavaScript_Event_onMouseOver(scintilla);
        }

        public void InsertJavaScript_Event_onMouseMove()
        {
            Sci_Middleware.InsertJavaScript_Event_onMouseMove(scintilla);
        }

        public void InsertJavaScript_Event_onMouseOut()
        {
            Sci_Middleware.InsertJavaScript_Event_onMouseOut(scintilla);
        }

        public void InsertJavaScript_Event_onFocus()
        {
            Sci_Middleware.InsertJavaScript_Event_onFocus(scintilla);
        }

        public void InsertJavaScript_Event_onBlur()
        {
            Sci_Middleware.InsertJavaScript_Event_onBlur(scintilla);
        }

        public void InsertJavaScript_Event_onKeypress()
        {
            Sci_Middleware.InsertJavaScript_Event_onKeypress(scintilla);
        }

        public void InsertJavaScript_Event_onKeydown()
        {
            Sci_Middleware.InsertJavaScript_Event_onKeydown(scintilla);
        }

        public void InsertJavaScript_Event_onKeypup()
        {
            Sci_Middleware.InsertJavaScript_Event_onKeypup(scintilla);
        }

        public void InsertJavaScript_Event_onSubmit()
        {
            Sci_Middleware.InsertJavaScript_Event_onSubmit(scintilla);
        }

        public void InsertJavaScript_Event_onReset()
        {
            Sci_Middleware.InsertJavaScript_Event_onReset(scintilla);
        }

        public void InsertJavaScript_Event_onSelect()
        {
            Sci_Middleware.InsertJavaScript_Event_onSelect(scintilla);
        }

        public void InsertJavaScript_Event_onChange()
        {
            Sci_Middleware.InsertJavaScript_Event_onChange(scintilla);
        }

        public void InsertJavaScript_If()
        {
            Sci_Middleware.InsertJavaScript_If(scintilla);
        }

        public void InsertJavaScript_If_Else()
        {
            Sci_Middleware.InsertJavaScript_If_Else(scintilla);
        }

        public void InsertJavaScript_Dowhile()
        {
            Sci_Middleware.InsertJavaScript_Dowhile(scintilla);
        }

        public void InsertJavaScript_While()
        {
            Sci_Middleware.InsertJavaScript_While(scintilla);
        }

        public void InsertJavaScript_For()
        {
            Sci_Middleware.InsertJavaScript_For(scintilla);
        }

        public void InsertJavaScript_For_i()
        {
            Sci_Middleware.InsertJavaScript_For_i(scintilla);
        }

        public void InsertJavaScript_Switch()
        {
            Sci_Middleware.InsertJavaScript_Switch(scintilla);
        }

        public void InsertJavaScript_ParseInt()
        {
            Sci_Middleware.InsertJavaScript_ParseInt(scintilla);
        }

        public void InsertJavaScript_ParseFloat()
        {
            Sci_Middleware.InsertJavaScript_ParseFloat(scintilla);
        }

        public void InsertJavaScript_isNaN()
        {
            Sci_Middleware.InsertJavaScript_isNaN(scintilla);
        }

        public void InsertJavaScript_komma2Point()
        {
            Sci_Middleware.InsertJavaScript_komma2Point(scintilla);
        }

        public void InsertJavaScript_toFixed()
        {
            Sci_Middleware.InsertJavaScript_toFixed(scintilla);
        }

        public void InsertJavaScript_split()
        {
            Sci_Middleware.InsertJavaScript_split(scintilla);
        }

        public void InsertJavaScript_Show_Popupwindow()
        {
            Sci_Middleware.InsertJavaScript_Popupwindow(scintilla);
        }



        public void InsertPHP_Range()
        {
            Sci_Middleware.InsertPHP_Range(scintilla);
        }


        public void InsertPHP_isset()
        {
            Sci_Middleware.PHP_InsertPHP_isset(scintilla);
        }


        public void InsertPHP_Isnumeric()
        {
            Sci_Middleware.InsertPHP_Isnumeric(scintilla);
        }

        public void InsertPHP_Intval()
        {
            Sci_Middleware.InsertPHP_IntVal(scintilla);
        }

        public void InsertPHP_echoText()
        {
            Sci_Middleware.InsertPHP_echoText(scintilla);
        }

        public void InsertPHP_echoStringAndVariable()
        {
            Sci_Middleware.InsertPHP_echoStringAndVariable(scintilla);
        }

        public void InsertPHP_echoStringAndVariable_withPoint()
        {
            Sci_Middleware.InsertPHP_echoStringAndVariable_withPoint(scintilla);
        }



    }  // RegPanel


}
